/******************************************************************************/
/*  %W% %D% %T%  */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*  C-headerfile:        Raphael M. Grochtmann     Aachen, 31.07.1990         */
/*                                                                            */
/*                                                                            */
/*        Bibliothek globale Konstanten, Typen, Variablen                     */
/******************************************************************************/



#include <stdio.h>		/* fuer Typen FILE (s.u.) */



/*   K O N S T A N T E N   */


#define STRLENGTH	30			/* Strings sind C-Strings ( 0<=Index<=29, abschl. '\0', z.B.: "a\0") */

#define MAXDISPLAYED	50		/* max. Anz. Zustaende, die angezeigt werden. dfa.c/DisplayAutomata */
#define NMAX			300		/* max. Anzahl an reellen und imaginaeren Zustaenden */
#define MMAX			5		/* benutzte Alphabetzeichen */
#define ZVORRAT			27		/* max. Alphabetgroesse */

#define DIRSYM          1		/* wird in main.c und dfa.c benoetigt */
#define DIRNOSYM        2
#define NODIRSYM        3
#define NODIRNOSYM      4

#define PRINT           TRUE	/* wird in main.c benoetigt */
#define DONTPRINT       FALSE



/*   T Y P E N   */


typedef int boolean;				/* boolean */
#define FALSE 0
#define TRUE  1


typedef char strg[STRLENGTH];		/* string */


typedef char setofchar[16];			/* setofchar */			/* 16 bytes (128 bits) fuer 128 chars */
#define Incl(s, c) (s[(c >> 3) & 15] |= 1 << (c & 7))		/* bits 3 bis 6 bestimmen das byte, */
#define Excl(s, c) (s[(c >> 3) & 15] &= ~(1 << (c & 7)))	/* bits 0 bis 2 bestimmen das bit.  */
#define In(s, c) (s[(c >> 3) & 15] & (1 << (c & 7)))		/* liefert > 0 falls enthalten, 0 sonst */
#define Clearset(s) (s[0]=s[1]=s[2]=s[3]=s[4]=s[5]=s[6]=s[7]\
	=s[8]=s[9]=s[10]=s[11]=s[12]=s[13]=s[14]=s[15]=0);



typedef struct s_pint pint;					/* Liste aus Integerzahlen */
typedef struct s_pint *pinteger;
struct s_pint {
	int		 	pi;
	pinteger 	psucc;
};

typedef struct s_transition transition;		/* Transitionsliste */
typedef struct s_transition *ptransition;
struct s_transition {
	int			q1;
	int			q2;
	char		tchar;
	ptransition	succ;
};

typedef struct s_ptupel ptupel;				/* Liste in Transitionstabelle */
struct s_ptupel {
	int			q;
	boolean		q0;
	setofchar	s;
	int			ssize;
	ptransition delta;
	int			qa;
	pinteger 	qe;
};

typedef struct s_pmat pmat;					/* Liste in Transitionstabelle */
typedef struct s_pmat *pmatrix;
struct s_pmat {
	int 		pmi;
	strg		pmstrg;
	pmatrix		pmsucc;
};
	  
typedef struct s_list list;
typedef struct s_list *plist;				/* Nachbarliste */
typedef struct s_vertex vertex;
typedef struct s_vertex *pvertex;			/* Zustandsliste */
struct s_list {
	int			edgeint;
	strg		edgest;
	pvertex		edge;
	plist		listsucc;
};
struct s_vertex {
	int			q;
	int			pos;
	int			xkoor;
	int			ykoor;
	double		barryleft;
	double		barryright;
	plist		pre;
	plist		suc;
	plist		levl;
	pvertex		vertsucc;
};

typedef struct s_level level;
typedef struct s_level *plevel;				/* Ebenenliste */
struct s_level {
	int			lev;
	int			qnumber;
	pvertex		qlist;
	plevel		levprec;
	plevel		levsucc;
};

typedef struct s_cover cover;
typedef struct s_cover *pcover;				/* Schalenliste */
struct s_cover {
	int			covnr;
	int			covar[NMAX+1];
	int			covfree;
	pcover		covsucc;
};

/* Fuer alle Matrizen gilt: relevante Indizes i: 1<=i<=max, der 0-te Index wird nicht benutzt! */
typedef pmatrix	matrixlistarray[NMAX+1][MMAX+1];
typedef pvertex	matrixlevelarray[NMAX+1];
typedef int		matrix1array[NMAX+1];
typedef int		posarray[ZVORRAT+1];


struct s_posrecord {
	int			q;
	boolean		exist;
	pvertex		vert;
};
typedef struct s_posrecord matrixposarray[NMAX+1];			/* in finetune, finetunesym verwand */



/*   globale  V A R I A B L E N  */	/* definiert in:		gebraucht in:					*/

extern boolean  printer;            /* dfa.c				dfa.c, graph.c					*/
extern FILE     *druck_fp;			/* dfa.c				dfa.c, graph.c					*/
extern char     full_filename[];    /* dfa.c				dfa.c, main.c, transamore.c		*/
extern boolean  epstrans;
extern char  epsletter;
extern int  laststate;
extern boolean  withoutlaststate;
