/******************************************************************************/
/*  %W% %D% %T%  */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*  Pascal-Programm:     Vera Kell                 Aachen, 31.07.1989         */
/*                                                                            */
/*  ANSI-C  Version:     Raphael M. Grochtmann     Aachen, 31.08.1990         */
/*                                                                            */
/*                                                                            */
/******************************************************************************/



#include <stdio.h>

#include "ext.h"
#include "list.h"



typedef char sethelparray[NMAX+1];



static void InitSetHelpPosition (setofchar s, sethelparray sethelp, posarray positiona)
	/* positiona und sethelparray sind Var-Parameter */
{
	char	c;
	int		i, j;

	j = 1;
	c = 'a';
	for (i = 1; i <= ZVORRAT - 1; i++) {
		if (In(s, c)) {
			sethelp[j] = c;
			positiona[i] = j;
			j++;
		} else
			positiona[i] = 0;
		c++;
	}
	c = ' ';
	if (In(s, c)) {
		sethelp[j] = c;
		positiona[ZVORRAT] = j;
	} else
		positiona[ZVORRAT] = 0;
} /* InitSetHelpPosition */



static void FindSymbol(ptupel a, matrixlistarray matrix, int vertanz)
	/* matrix ist Var-Parameter */
{
	int			i, j, k, help, count;
	sethelparray 	  	setsigma;
	posarray		possigma;
	pmatrix			pmhelp1, pmhelp2;
	strg			symbol;
        /* matrix : zustand,buchstabe -> liste von zustaenden */
        /* gesucht  zustand,buchstabe -> liste von zustaenden mit folge von Buchstaben */
        /*  matrix[i][j]->pmstrg  == '\0' bedeuted: Transition schon woanders eingefuegt */
        /* Idee: zu allen Zustaenden: suche Transition mit diesem Zustand, 
         *                            falls gefunden: suche weitere Buchstaben die die beiden 
         *                                            Zustaende verbinden
         */

	InitSetHelpPosition(a.s, setsigma, possigma);
	for (i = 1; i <= vertanz; i++)
		for (j = 1; j <= a.ssize; j++) {
			count = 1;
			for (k = 0; k < STRLENGTH; k++) symbol[k] = '\0';
			pmhelp1 = matrix[i][j];
			while (pmhelp1 != NULL) {
				if (pmhelp1->pmstrg[0] != '\0') {
					symbol[count-1] = setsigma[j];
					if (j != a.ssize)
						for (help = j+1; help <= a.ssize; help++) {
							pmhelp2 = matrix[i][help];
							while (pmhelp2 != NULL) {
								if (pmhelp2->pmi == pmhelp1->pmi) {
									count++;
									symbol[count-1] = setsigma[help];
									symbol[count] = '\0';
									pmhelp2->pmstrg[0] = '\0';
								}
								pmhelp2 = pmhelp2->pmsucc;
							}
						}
				}
				strcpy(pmhelp1->pmstrg, symbol);
				pmhelp1 = pmhelp1->pmsucc;
                                count = 1;    /* neu eingefuegt */
			        for (k = 0; k < STRLENGTH; k++) symbol[k] = '\0';
			}
		}
} /* FindSymbol */



static void DelState(matrixlistarray matrix, int state, int ssize)
	/* matrix ist Var-Parameter */
{
	int j;

	for (j = 1; j <= ssize; j++)
		if (matrix[state][j] != NULL) {
			MatListDel(&matrix[state][j]);
			matrix[state][j] = NULL;
		}
} /* DelState */



static void DelNotReachableState(ptupel a, matrixlistarray matrix)
	/* matrix ist Var-Parameter */
{
	int j;
	pinteger prelist, prehelp, actlist, acthelp;
	boolean qexist[NMAX+1];
	pmatrix mathelp;

	for (j = 1; j <= NMAX; j++)
		qexist[j] = FALSE;
	IntListBeg(&prelist, a.qa);
	qexist[a.qa] = TRUE;
	while (prelist != NULL) {
		actlist = NULL;
		prehelp = prelist;
		while (prehelp != NULL) {
			for (j = 1; j <= a.ssize; j++) {
				mathelp = matrix[prehelp->pi][j];
				while (mathelp != NULL) {
					if (qexist[mathelp->pmi] == FALSE) {
						qexist[mathelp->pmi] = TRUE;
						if (actlist == NULL) {
							IntListBeg(&actlist, mathelp->pmi);
							acthelp = actlist;
						} else
							IntListAddEnd(&acthelp, mathelp->pmi);
					}
					mathelp = mathelp->pmsucc;
				}
			}
			prehelp = prehelp->psucc;
		}
		prehelp = prelist;
		prelist = actlist;
		if (prehelp != NULL)
			IntListDel(&prehelp);
	}
	if (actlist != NULL)
		IntListDel(&actlist);
	for (j = 1; j <= a.q; j++)
		if (qexist[j] == FALSE)
			DelState(matrix, j, a.ssize);
} /* DelNotReachableState */



static int CharPosition(char c)
	/* CharPosition('a')=1, ..., CharPosition('z')=26, CharPosition(' ')=27 */
{
	return (c == ' ') ? 27 : c - 'a' + 1;
} /* CharPosition */



void AutTabTransform (ptupel a, matrixlistarray matrix)
	/* matrix ist Var-Parameter */
	/* Tabellenaufbau: Spalten -> Alphabet und Zeilen -> Zustaende 
	Inhalte -> Zustandslisten */
{
	sethelparray		sethelp;
	posarray		positiona;
	ptransition		t;
	int			i, j;
	matrixlistarray		mathelp;
	strg			st;

	InitSetHelpPosition(a.s, sethelp, positiona);
	st[0] = '?';
	for (i = 1; i < STRLENGTH; i++)
		st[i] = '\0';
	matrix[1][1] = NULL;
	for (i = 1; i <= a.q; i++)
		for (j = 1; j <= a.ssize; j++)
			matrix[i][j] = mathelp[i][j] = NULL;
	t = a.delta;
	while (t != NULL) {
		j = positiona[CharPosition(t->tchar)];
		if (mathelp[t->q1][j] == NULL) {
			MatListBeg(&mathelp[t->q1][j], t->q2, st);
			matrix[t->q1][j] = mathelp[t->q1][j];
		} else
			MatListAddEnd(&mathelp[t->q1][j], t->q2, st);
		t = t->succ;
	}
	DelNotReachableState(a, matrix);
	FindSymbol(a, matrix, a.q);
}  /* AutTabTransform */



static void TestDoubleArrow(int q1, int q2, int ssize, matrixlistarray matrix, boolean *doublearrow)
	/* matrix ist NICHT Var-Parameter (daher lokale Kopie, s.u.) */
	/* Prozedur testet, ob es sich um einen Doppelpfeil handelt */
{
	int			j;
	pmatrix		help;

	*doublearrow = FALSE;
	if (q1 != q2)
		for (j = 1; j <= ssize; j++) {
			help = matrix[q2][j];				/* Kopie des Matixelements */
			while (help != NULL  &&  *doublearrow == FALSE) {
				if (help->pmi == q1)
					*doublearrow = TRUE;
				help = help->pmsucc;
			}
		}
} /* TestDoubleArrow */



void LevelPositionSort(pvertex qlist)
	/* Sortieren der Zustaende (qlist) innerhalb einer Ebene */
{
	int levcount, i, j;
	pvertex ql;
	matrixlevelarray levelmat;

	levcount = 0;								/* Anzahl der Zustaende der akt. Ebene */
	for (i = 1; i <= NMAX; i++)
		levelmat[i] = NULL;						/* levelmat: Zustaende der akt. Ebene */
	while (qlist != NULL) {
		levelmat[++levcount] = qlist;
		qlist = qlist->vertsucc;
	}
	for (i = 1; i <= levcount; i++)				/* Sortieren der Zustaende anhand der */
		for (j = 1; j <= levcount - i; j++)		/* Positionen (Bubblesort) */
			if (levelmat[j + 1]->pos < levelmat[j]->pos) {
				ql = levelmat[j + 1];
				levelmat[j + 1] = levelmat[j];
				levelmat[j] = ql;
			}
	for (i = 1; i <= levcount; i++)
		levelmat[i]->pos = i;
} /* LevelPositionSort */



static void CreateIQList(int *qnumber, pvertex *qliste, int actlevel,
					ptupel a, matrixlistarray matrix, matrix1array qlevel, plevel levhelp)
	/* die vier letzten Par. wurden angefuegt (CreateIQList war sub-procedure in CreateILevel) */
{
	pmatrix pmhelp;
	pvertex qhelp, qprelist, qsuch;
	int j, vor, nach, leveldist;
	boolean doubleb;

	*qnumber = 0;				/* Anzahl der Zustaende der akt. Ebene */
	qprelist = *qliste;			/* Zustandsliste der vorherigen Ebene */
	*qliste = NULL;
	if (qprelist == NULL) {		/* 1.Ebene mit Anfangszustand besetzen */
		*qnumber = 1;
		qlevel[a.qa] = actlevel;
		VertexListBeg(qliste, a.qa, 1, 0, 0);
	} else {
		while (qprelist != NULL) {
			for (j = 1; j <= a.ssize; j++) {
				vor = qprelist->q;
				pmhelp = matrix[vor][j];
				while (pmhelp != NULL) {
					nach = pmhelp->pmi;
					if (qlevel[nach] == 0) {		/* Zuordnen eines noch nicht vorhan- */
						qlevel[nach] = actlevel;	/* denen Zustandes zur akt. Ebene    */
						(*qnumber)++;
						if (*qnumber == 1) {		/* 1.Element der akt. Zustandsliste */
							VertexListBeg(&qhelp, nach, *qnumber, 0, 0);
							AddPreSucVertex(&qprelist, &qhelp);		/* Kanten, die von */
							*qliste = qhelp;		/* einem Zustand ausgehen, hinzufuegen */
						} else {				/* Hinzufuegen eines neuen Zustandes am Ende der Liste*/
							VertexListAddEnd(&qhelp, nach, *qnumber, 0, 0);
							AddPreSucVertex(&qprelist, &qhelp);
						}
					} else {						/* Einfuehren nicht beruecksichtigter Kanten */
						leveldist = qlevel[vor] - qlevel[nach];
						if (leveldist == -1) {		/* Hinkante zu einem Knoten, der in der */
							qsuch = *qliste;		/* akt. Ebene schon vorhanden ist */
							while (qsuch != NULL  &&  qsuch->q != nach)
								qsuch = qsuch->vertsucc;
							if (qsuch != NULL)
								AddPreSucVertex(&qprelist, &qsuch);
						} else if (leveldist == 1) {	/* triviale Rueckkante */
							TestDoubleArrow(vor, nach, a.ssize, matrix, &doubleb);
							if (doubleb == FALSE) {
								qsuch = levhelp->levprec->qlist;
								while (qsuch != NULL  &&  qsuch->q != nach)
									qsuch = qsuch->vertsucc;
								if (qsuch != NULL)
									AddPreSucVertex(&qsuch, &qprelist);
							}
						}
					}
					pmhelp = pmhelp->pmsucc;
				}
			}/*for (j = 1; j <= a.ssize; j++)*/
			qprelist = qprelist->vertsucc;
		}/*while (qprelist != NULL)*/
	}/*else*/
}  /* CreateIQList */



static void CreateILevel(ptupel a, matrixlistarray matrix, plevel *levliste, matrix1array qlevel,
				int *statenr, int *length, int *width)
	/* matrix (und levliste) und qlevel (und statenr, length, width) sind Var-Parameter */
{
	plevel levhelp;
	pvertex qlist;
	int j1, qnr, actlev;

	*statenr = a.q;								/* Anzahl der Zustaende ohne Dummyknoten */
    for (j1 = 1; j1 <= NMAX; j1++)				/* Initialisierung, gibt Ebene an, */
		qlevel[j1] = 0;							/* in der der Zustand j1 vorkommt */
	actlev = 1;									/* aktuelle Ebene */
	qlist = NULL; qnr = 1;						/* Zustandsliste einer Ebene */
	CreateIQList(&qnr, &qlist, actlev, a, matrix, qlevel, levhelp);
		/* Aufbau der Zustandsliste einer Ebene */
	*length = actlev;							/* Maximale Anzahl der Ebene */
	*width = qnr;								/* Maximale Anzahl von Zustaenden in einer Ebene */
	*levliste = NULL;
	levhelp = NULL;
	LevelListBeg(&levhelp, actlev, qnr, qlist);	/* Aufbau der Ebenenliste */
	*levliste = levhelp;
	while (qlist != NULL) {
		actlev++;
		CreateIQList(&qnr, &qlist, actlev, a, matrix, qlevel, levhelp);
		if (qlist != NULL) {
			LevelListAddEnd(&levhelp, actlev, qnr, qlist);
			*length = actlev;
			if (qnr > *width)  *width = qnr;
		}
	}
}  /* CreateILevel */



static void AddIDummyVertex(pvertex *prevert, int dumvert, int dumlev, int dumpos, plevel levl)
{
	pvertex ql;
	int i;

	for (i = 1; i <= dumlev - 1; i++)
		levl = levl->levsucc;
	ql = levl->qlist;
	while (ql->vertsucc != NULL)
		ql = ql->vertsucc;
	VertexListAddEnd(&ql, dumvert, dumpos * (abs(ql->pos) + 1), 0, 0);
	AddPreSucVertex(&ql, prevert);
	*prevert = ql;
	levl->qnumber++;
} /* AddIDummyVertex */



static void AddIIDummyVertex(pvertex *prevert, int dumvert, int dumlev, plevel levl)
{
	pvertex ql;
	int i;

	for (i = 1; i <= dumlev - 1; i++) levl = levl->levsucc;
	ql = levl->qlist;
	while (ql->vertsucc != NULL) ql = ql->vertsucc;
	VertexListAddEnd(&ql, dumvert, ql->pos + 1, 0, 0);
	AddPreSucVertex(&ql, prevert);
	*prevert = ql;
	levl->qnumber++;
} /* AddIIDummyVertex */



static void DummyBackVertex(int *dumnr, int levdistance, int lev, int ssize,
					pvertex qvor, pmatrix pmnach, matrixlistarray mat,
					plevel levl, matrix1array qanzar, boolean *dumbreak)
{
	/* (dumnr,) mat und qanzar (und dumbreak) sind Var-Parameter */
	int dumpos, begedge, endedge, levnach, i, j, stplace;
	double middleposvor, middleposnach, dumrealpos;
	strg st, pmst, sthelp;
	pvertex vertdum, ql;
	plevel levlhelp;

	dumpos = 1;
	begedge = qvor->q;
	endedge = pmnach->pmi;
	levlhelp = levl;
	levnach = lev - levdistance;
	for (i = 1; i <= lev - levdistance - 1; i++) levlhelp = levlhelp->levsucc;
	ql = levlhelp->qlist;
	while (ql->q != endedge  &&  ql != NULL) ql = ql->vertsucc;
	if (ql != NULL) {
		middleposvor = (double)qanzar[lev] * ((double)qanzar[lev] + 1) / 4.0;
		if (middleposvor == 0.5)  middleposvor = 1;
		middleposnach = (double)qanzar[levnach] * ((double)qanzar[levnach] + 1) / 4.0;
		if (middleposnach == 0.5)  middleposnach = 1;
		dumrealpos = (qvor->pos-middleposvor) + (ql->pos - middleposnach);
		dumpos = (dumrealpos >= 0) ? 1 : -1;
	}
	pmnach->pmi = *dumnr + 1;
	stplace = trunc((levdistance - 1) / 2.0);
	if (stplace != 0) {
		strcpy(pmst, pmnach->pmstrg);
		pmnach->pmstrg[0] = '\0';
	}
	vertdum = qvor;
	(*dumnr)++;
	if (*dumnr >= NMAX) {
		*dumbreak = TRUE;
		*dumnr = NMAX - 1;
	}
	for (i = 1; i <= levdistance - 2; i++) {
		if (stplace == i)
			strcpy(st, pmst);
		else
			st[0] = '\0';
		for (j = 1; j <= ssize; j++)
			mat[*dumnr][j] = NULL;
		MatListBeg(&mat[*dumnr][1], *dumnr + 1, st);
		AddIDummyVertex(&vertdum, *dumnr, lev - i, dumpos, levl);
		(*dumnr)++;
		if (*dumnr >= NMAX) {
			*dumbreak = TRUE;
			*dumnr = NMAX - 1;
		}
	}
	for (j = 1; j <= ssize; j++)
		mat[*dumnr][j] = NULL;
	sthelp[0] = '\0';
	MatListBeg(&mat[*dumnr][1], endedge, sthelp);
	AddIDummyVertex(&vertdum, *dumnr, lev-levdistance+1, dumpos, levl);
	AddPreSucVertex(&ql, &vertdum);
} /* DummyBackVertex */



static void DummyLevelVertex(int lev, int ssize, pvertex qvor, pmatrix pmnach, plevel levl)
{
	int endedge, dumnr, i;
	pvertex vertdum, ql;

	dumnr = -1;
	endedge = pmnach->pmi;
	vertdum = qvor;
	AddIIDummyVertex(&vertdum, dumnr, lev - 1, levl);
	for (i = 1; i <= lev - 1; i++)
		levl = levl->levsucc;
	ql = levl->qlist;
	while (ql->q != endedge  &&  ql != NULL)
		ql = ql->vertsucc;
	AddPreSucVertex(&vertdum, &ql);
} /* DummyLevelVertex */


void AddIDummyLev(ptupel a, matrixlistarray matrix, plevel *levliste, 
				int *statenr, int *length, int *width, boolean *dumbreak)
	/* matrix (und levliste, statenr, length, width, dumbreak) sind var-Parameter */
{
	int				j, vor, nach, leveldist, actlev;
	boolean			loopb, doubleb;
	matrix1array	qlevelar, qanzahlar;
	pvertex			qlist, qsuch;
	pmatrix			pmhelp;
	plevel			levhelp;

	actlev = 1;
	CreateILevel(a, matrix, levliste, qlevelar, statenr, length, width);
	levhelp = *levliste;
	j = 0;
	while (levhelp != NULL) {
		j++;
		qanzahlar[j] = levhelp->qnumber;
		levhelp = levhelp->levsucc;
	}
	levhelp = (*levliste)->levsucc;
	while (levhelp != NULL) {
		actlev++;
		qlist = levhelp->qlist;
		while (qlist != NULL) {
			for (j = 1; j <= a.ssize; j++) {
				vor = qlist->q;
				pmhelp = matrix[vor][j];
				while (pmhelp != NULL) {
					nach = pmhelp->pmi;
					leveldist = qlevelar[vor] - qlevelar[nach];
					if (pmhelp->pmstrg[0] != '\0') {
						if (leveldist > 1)
							DummyBackVertex(statenr, leveldist, actlev, a.ssize, 
								qlist, pmhelp, matrix, *levliste, qanzahlar, dumbreak);
						else if (leveldist == 0) {
							loopb = (vor == nach) ? TRUE : FALSE;
							if (loopb != TRUE) {
								TestDoubleArrow(vor, nach, a.ssize, matrix, &doubleb);
								if (doubleb == FALSE) 
									DummyLevelVertex(actlev, a.ssize, qlist, pmhelp, *levliste);
								else {
									qsuch = levhelp->qlist;
									while (qsuch != NULL  &&  qsuch->q != nach)
										qsuch = qsuch->vertsucc;
									if (qsuch != NULL  &&  qsuch->pos > qlist->pos) 
										DummyLevelVertex(actlev, a.ssize, qlist, pmhelp, *levliste);
								}
							}
						}
					}
					pmhelp = pmhelp->pmsucc;
				}
			}
			qlist = qlist->vertsucc;
		}
		levhelp = levhelp->levsucc;
	}
	levhelp = *levliste;
	while (levhelp != NULL) {
		LevelPositionSort(levhelp->qlist);
		if (*width < levhelp->qnumber)
			*width = levhelp->qnumber;
		levhelp = levhelp->levsucc;
	}
} /* AddIDummyLev */



static void CreateIIQList (int *qnumber, pvertex *qliste, int actlevel,
					ptupel a, matrixlistarray matrix, matrix1array qlevel, plevel levhelp)
	/* die vier letzten Par. wurden angefuegt (CreateIIQList war sub-procedure in CreateIILevel) */
{
	boolean doubleb;
	pmatrix pmhelp;
	pvertex qhelp, qprelist, qsuch;
	int vor, nach, i, j, leveldist;

	*qnumber = 0;								/* Anzahl der Zustaende der akt. Ebene */
	qprelist = *qliste;							/* Zustandsliste der vorherigen Ebene */
	*qliste = NULL;
	if (qprelist == NULL) {						/* 1.Ebene mit Anfangszustand besetzen */
		*qnumber = 1;
		qlevel[a.qa] = actlevel;
		VertexListBeg(qliste, a.qa, 1, 0, 0);
	} else {
		while (qprelist != NULL) {
			vor = qprelist->q;
			for (j = 1; j <= a.ssize; j++) {
				pmhelp = matrix[vor][j];
				while (pmhelp != NULL) {
					nach = pmhelp->pmi;
					if (qlevel[nach] == 0) {			/* Zuordnen eines noch nicht vorhan- */
						qlevel[nach] = actlevel;		/* denen Zustandes zur akt. Ebene */
						(*qnumber)++;
						if (*qnumber == 1) {			/* 1.Element der akt. Zustandsliste */
							VertexListBeg(&qhelp, nach, *qnumber, 0, 0);
							AddPreSucVertex(&qprelist, &qhelp);	/* Kanten, die von */
							*qliste = qhelp;				/* dem Knoten ausgehen, hinzufuegen */
						} else {				/* Hinzufuegen eines neuen Zustandes am Ende der Liste */
							VertexListAddEnd(&qhelp, nach, *qnumber, 0, 0);
							AddPreSucVertex(&qprelist, &qhelp);
						}
					} else {							/* Einfuehren nicht beruecksichtigter Kanten */
						leveldist = qlevel[vor] - qlevel[nach];
						if (leveldist == -1) {			/* Hinkante zu einem Knoten, der in der */
							qsuch = *qliste;				/* akt. Ebene schon vorhanden ist */
							while (qsuch != NULL  &&  qsuch->q != nach)
								qsuch = qsuch->vertsucc;
							if (qsuch != NULL)
								AddPreSucVertex(&qprelist, &qsuch);
						} else if (leveldist == 1) {	/* triviale Rueckkante */
							TestDoubleArrow(vor, nach, a.ssize, matrix, &doubleb);
							if (doubleb == FALSE) {
								qsuch = levhelp->levprec->qlist;
								while (qsuch != NULL  &&  qsuch->q != nach)
									qsuch = qsuch->vertsucc;
								if (qsuch != NULL)
									AddPreSucVertex(&qsuch, &qprelist);
							}
						}
					}
					pmhelp = pmhelp->pmsucc;
				}
			}
			for (i = 1; i <= a.q; i++) {
				if (qlevel[i] == 0) {
					for (j = 1; j <= a.ssize; j++) {
						pmhelp = matrix[i][j];
						while (pmhelp != NULL) {
							if (qlevel[i] == 0) {
								nach = pmhelp->pmi;
								if (nach == vor) {			/* Zuordnen eines noch nicht vorhandenen */
									qlevel[i] = actlevel;	/* Zustandes zur akt. Ebene    */
									(*qnumber)++;
									if (*qnumber == 1) {		/* 1.Element der akt. Zustandsliste */
										VertexListBeg(&qhelp, i, *qnumber, 0, 0);
										AddPreSucVertex(&qprelist, &qhelp);		/* Kanten, die von */
										*qliste = qhelp;		/* dem Knoten ausgehen, hinzufuegen */
									} else {	/* Hinzufuegen eines neuen Zustandes am Ende der Liste */
										VertexListAddEnd(&qhelp, i, *qnumber, 0, 0);
										AddPreSucVertex(&qprelist, &qhelp);
									}
								}
							}
							pmhelp = pmhelp->pmsucc;
						}
					}
				}
			}
			qprelist = qprelist->vertsucc;
		}
	}
} /* CreateIIQList */



static void CreateIILevel(ptupel a, matrixlistarray matrix, plevel *levliste, matrix1array qlevel,
				int *statenr, int *length, int *width)
	/* matrix (und levliste, statenr, length, width) und qlevel sind Var-Parameter */
{
	plevel levhelp;
	pvertex qlist;
	int j1, qnr, actlev;

	*statenr = a.q;									/* Anzahl der Zustaende ohne Dummyknoten */
	for (j1 = 1; j1 <= NMAX; j1++)							/* Initialisierung */
		qlevel[j1] = 0;								/* Gibt Ebene an, in der der Zustand j1 vorkommt */
	actlev = 1;										/* aktuelle Ebene */
	qlist = NULL;									/* Zustandsliste einer Ebene */
	CreateIIQList(&qnr, &qlist, actlev, a, matrix, qlevel, levhelp);	
		/* Aufbau der Zustandsliste einer Ebene */
	*length = actlev;								/* Maximale Anzahl der Ebene */
	*width = qnr;									/* Maximale Anzahl von Zustaenden in einer Ebene */
	*levliste = NULL;
	levhelp = NULL;
	LevelListBeg(&levhelp, actlev, qnr, qlist);		/* Aufbau der Ebenenliste */
	*levliste = levhelp;
	while (qlist != NULL) {
		actlev++;
		CreateIIQList(&qnr, &qlist, actlev, a, matrix, qlevel, levhelp);
		if (qlist != NULL) {
			LevelListAddEnd(&levhelp, actlev, qnr, qlist);
			*length = actlev;
			if (qnr > *width)
				*width = qnr;
		}
	}
}  /* CreateIILevel */



void AddIIDummyLev(ptupel a, matrixlistarray matrix, plevel *levliste, 
				int *statenr, int *length, int *width)
	/* matrix (und levliste, statenr, length, width) sind var-Parameter */
{
	int				j, vor, nach, leveldist, actlev;
	boolean			loopb, doubleb;
	matrix1array	qlevelar;
	pvertex			qlist, qsuch;
	pmatrix			pmhelp;
	plevel			levhelp;

	actlev = 1;
	CreateIILevel(a, matrix, levliste, qlevelar, statenr, length, width);
	levhelp = (*levliste)->levsucc;
	while (levhelp != NULL) {
		actlev++;
		qlist = levhelp->qlist;
		while (qlist != NULL) {
			for (j = 1; j <= a.ssize; j++) {
				vor = qlist->q;
				pmhelp = matrix[vor][j];
				while (pmhelp != NULL) {
					nach = pmhelp->pmi;
					leveldist = qlevelar[vor] - qlevelar[nach];
					if (leveldist == 0) {
						loopb = (vor == nach) ? TRUE : FALSE;
						if (loopb != TRUE) {
							TestDoubleArrow(vor, nach, a.ssize, matrix, &doubleb);
							if (doubleb == FALSE)
								DummyLevelVertex(actlev, a.ssize, qlist, pmhelp, *levliste);
							else {
								qsuch = levhelp->qlist;
								while (qsuch != NULL  &&  qsuch->q != nach)
									qsuch = qsuch->vertsucc;
								if (qsuch != NULL  &&  qsuch->pos > qlist->pos) 
									DummyLevelVertex(actlev, a.ssize, qlist, pmhelp, *levliste);
							}
						}
					}
					pmhelp = pmhelp->pmsucc;
				}
			}
			qlist = qlist->vertsucc;
		}
		levhelp = levhelp->levsucc;
	}
	while (levhelp != NULL) {
		if (*width < levhelp->qnumber)
			*width = levhelp->qnumber;
		levhelp = levhelp->levsucc;
	}
} /* AddIIDummyLev */
