#ifndef ADJUST_H
#define ADJUST_H

/* 
   Bordeaux : 1995 
   */

#include "ext.h"

/* the but of this little module is to permit, in any procedure,
   to choose a reference automaton type (DFA or NFA) without having 
   incessants conversion between the two types to automatons to do :
   they are effectued by the functions of this module.
   This module is used in the modules of the amore-bx version (fa_utils,
   fa_word, codetest, propcode, win_una2, two_fact). */
   

/* -------------------------- Part 1 : tests ---------------------------- */

boole adjust_inclusion_dfa(dfa X_dfa1, dfa X_dfa2);
boole adjust_disjunction_dfa(dfa X_dfa1, dfa X_dfa2);
boole adjust_inclusion_nfa(nfa X_nfa1, nfa X_nfa2);
boole adjust_disjunction_nfa(nfa X_nfa1, nfa X_nfa2);
boole adjust_equiv_nfa(nfa X_nfa1, nfa X_nfa2);

/* ------------------ Part 1 : operations with DFAs --------------------- */

dfa adjust_union_dfa(dfa X_dfa1, dfa X_dfa2);
dfa adjust_concat_dfa(dfa X_dfa1, dfa X_dfa2);
dfa adjust_shuffle_dfa(dfa X_dfa1, dfa X_dfa2);
dfa adjust_insec_dfa(dfa X_dfa1, dfa X_dfa2);
dfa adjust_minus_dfa(dfa X_dfa1, dfa X_dfa2);
dfa adjust_leftquot_dfa(dfa X_dfa1, dfa X_dfa2);
dfa adjust_star_dfa(dfa X_dfa);
dfa adjust_plus_dfa(dfa X_dfa);
dfa adjust_rev_dfa(dfa X_dfa);
dfa adjust_suff_dfa(dfa X_dfa);

/* ------------------ Part 1 : operations with NFAs --------------------- */

nfa adjust_insec_nfa(nfa X_nfa1, nfa X_nfa2);
nfa adjust_minus_nfa(nfa X_nfa1, nfa X_nfa2);
nfa adjust_leftquot_nfa(nfa X_nfa1, nfa X_nfa2);
nfa adjust_rightquot_nfa(nfa X_nfa1, nfa X_nfa2);
nfa adjust_star_nfa(nfa X_nfa);
nfa adjust_plus_nfa(nfa X_nfa);
nfa adjust_compl_nfa(nfa X_nfa);
nfa adjust_minL_nfa(nfa X_nfa);
nfa adjust_maxL_nfa(nfa X_nfa);
nfa adjust_pref_nfa(nfa X_nfa);
nfa adjust_suff_nfa(nfa X_nfa);

#endif 



