/* atime.c 3.0 (KIEL) 11.94 */

#include "ext.h"

#ifdef DOS
#include <sys\types.h>
#include <sys\timeb.h>
#endif
#ifdef SYS5
#include <sys/types.h>
#include <sys/times.h>
#include <sys/param.h>
#endif
#ifdef BSD43
#include <sys/time.h>
#include <sys/resource.h>
#endif


#define TICKROW 23 
#define TICKMOD	67

/* functions included
 *
 *	void newtick
 *	void cpuclock
 *	void clock_reset
 *	void tack
 */

static int running = 0;

static posint tickcount;
static short int tickcol;

static long starttime=0, endtime=0;

/******************************************************************/
/******************************************************************/
void
newtick(str,n)
string str;
posint n;
{	tickcount = 0;
	mvaddstr(TICKROW,2,"ACTION >> ");
	clrtoeol(); addstr(str);
	addstr("  (");
	if (n) addstr(pi2a(n));
	else   addstr("exp.");
	addstr(") "); refresh();
	tickcol = strlen(str) + 30;
} /* newtick */

/******************************************************************/
#ifdef DOS
void
cpuclock(who)
int who;
/* who: procedure which starts the clock must end the clock */
{ struct timeb ltime;
	if ((running != 0) && (who != running)) return;
	running = who;
	ftime(&ltime);
	if (starttime) {
		endtime = ltime.time*1000+ltime.millitm;
		comptime = endtime - starttime;
		starttime = 0; running  = 0;
	} else {
		starttime = ltime.time*1000+ltime.millitm;
		comptime = 0;
	}
} /* clock */
#endif
/******************************************************************/
#ifdef SYS5
void
cpuclock(who)
int who;
/* who: procedure which starts the clock must end the clock */
{ 
struct tms usedtime;
	if ((running != 0) && (who != running)) return;
	running = who;
	(void)times(&usedtime);
	if (starttime) {
		endtime = ((usedtime.tms_utime* 1000)/HZ) ;
		comptime = endtime - starttime;
		starttime = 0; running  = 0;
	} else {
		starttime = ((usedtime.tms_utime* 1000)/HZ);
		comptime = 0;
	}
} 
/* clock */
#endif
/******************************************************************/
#ifdef BSD43
void
cpuclock(who)
int who;
/* who: procedure which starts the clock must end the clock */
{ struct rusage ru;
        if ((running != 0) && (who != running)) return;
        running = who;
        (void) getrusage(RUSAGE_SELF, &ru);
        if (starttime) {
                endtime = ((ru.ru_utime.tv_sec * 1000) + (ru.ru_utime.tv_usec /1000));
                comptime = endtime - starttime;
                starttime = 0; running  = 0;
        } else {
                starttime = ((ru.ru_utime.tv_sec * 1000) + (ru.ru_utime.tv_usec
/1000));
                comptime = 0;
        }
} /* clock */
#endif
/******************************************************************/
void 
resettime()
{
 running=0;
 comptime=0;
 starttime=0;
}
/******************************************************************/
void
tack()
/* counter */
{	if (!tickon) return;
	if (tickcount++ % TICKMOD == 0) {
		mvaddstr(TICKROW,tickcol,pi2a(tickcount)); refresh();
	}
} /* tack */

/******************************************************************/
void
clock_reset()
{ comptime = 0; running = 0;
} /* clock_reset */
