/* edfa.c 3.0 (KIEL) 11.94 */

#include "ext.h"

/* functions included 
 *	static	void  howtouse()
 *	static  void  input()
 *	static	void  setvars()
 *	static  void  detboard()
 *	static	void  initscrvars()
 *	static	void  showtr()
 *	static  void  addel()
 *	static  void edloop()
 *
 *	       posint edit()
 */

static posint **dbuffer = NULL; /* buffer for the dfa */
static boole ***nbuffer = NULL; /* buffer for the nfa */

static int scrcol,scrrow;	/* current screen position */
static int rowjump,coljump;     /* distance between columns and rows */
static int rowpage,colpage;     /* rows (columns) pro page */
static int rowmin,rowmax;	/* minimal and maximal row number */
static int colmin,colmax;	/* minimal and maximal column number */
static posint stateno,letterno;
	/* number of states and letters in the automaton */
static posint startlet;		 /* first letter */
static posint bufletter,bufstate;
	/* indices for the buffer to address letter/state transitions */
static posint bc,br;
	/* bc is the first letter in the letter line and br is the first
 	 * state in the state line
 	 */
static char neuchar;

static boole nondet;		/* TRUE iff nfa */
static boole viewonly;
static mrkfin   infin;          /* buffer for initial/final states */
static posint   init;           /* initial state , used only for dfa */
/******************************************************************/
/******************************************************************/
#define LINE1	"h: left  j: down  k: up  l: right  g: goto                  q: quit"
#define NLINE2	"f: switch final ('Q')    i: switch initial ('*')  0-9: new state list"
#define DLINE2	"f: switch final ('Q')    i: mark initial ('*')     0-9: enter state"
#define NLINE3	"s: show all states       a: add a state           d: delete a state"
#define NLINE3V	"s: show all states"

static void
howtouse()
/* a tutorial */
{	cleartut();

	if (nondet) {
		if (viewonly) mvaddstr(LASTROW+2,LRCOL,NLINE3V); 
		else {
			mvaddstr(LASTROW+1,LRCOL,NLINE2);
			mvaddstr(LASTROW+2,LRCOL,NLINE3);
		}
		mvaddstr(LASTROW  ,LRCOL,LINE1);
	} else {
		mvaddstr(LASTROW+1,LRCOL,LINE1);
		if (!viewonly) mvaddstr(LASTROW+2,LRCOL,DLINE2);
	}

	if (!viewonly) move(scrrow,scrcol);
	refresh();
} /* howtouse */

/******************************************************************/
static void input(ch)
char ch;
{ posint res,s;
  char dig=ch;
  boole digit=TRUE;
  /* clear working area and write a 'q' */
  if(nondet) 
     for(s=0; s<=stateno; s++)
         disconnect(nbuffer,bufletter,bufstate,s);
  else 
     dbuffer[bufletter][bufstate] = stateno+1;
  for(s=coljump; s; s--) addch(' ');
  move(scrrow,scrcol); 
  addstr("q");
  addch(dig);
  refresh();
  res = dig - '0'; 
  if(res)  /* input != 0 */
    {while((res <= stateno) && (digit))
       {dig = getch();
        if(isdigit(dig))
          {res=10*res + (dig -'0');
           addch(dig);
           refresh();
          } 
        else
           digit=FALSE;
       }
    }
  if(digit&&res) /* number too large */
    {cleartut();
     addstr("No valid state!");
     move(scrrow,scrcol);
     for(s=0;s<coljump;s++)addch(' ');
     move(scrrow,scrcol);
     refresh();
     sleep(1);
     howtouse();
    }
  else
    {if(nondet) connect(nbuffer,bufletter,bufstate,res);
     else       dbuffer[bufletter][bufstate] = res;
     if(res)    neuchar = dig;
    }
} /* input */

/******************************************************************/
static void
setvars(dir)
char dir;
/* change values of static variables according to the visible part
 * of the buffer 
 */
{
int row, col;
posint s;
	/* first: compute the value of the upper left corner (br,bc) */
	switch (dir) {
	case 'h': if (bc > colpage) bc -= colpage; else bc = startlet;
		  break; 
	case 'j': br += rowpage;
		  if (br+rowpage > stateno) br = stateno-rowpage+1;
		  break;
	case 'k': if (br > rowpage) br -= rowpage; else br = 0;
		  break;
	case 'l': bc += colpage;
		  if (bc+colpage > letterno) bc = letterno-colpage+1;
		  break;
	case 'g': cleartut();
		  addstr("Goto element no: ");
                  gtyx(stdscr,row,col); refresh();
		  s = rdpnum(TRUE,row,col);
		  if (s <= stateno) {
			  bc = startlet; br = s;
			  if (br+rowpage > stateno) br = stateno - rowpage + 1;
			  bufstate = br; bufletter = bc;
		  } else { mvaddstr(LASTROW+1,LRCOL,"No valid state!");
			   refresh(); sleep(1);howtouse();
		  }
		  break;
	case 'i': /* this is the initialization  step */
		  bufletter = startlet; bufstate = 0;
	          br = 0; bc = startlet;
		  break;
	default : /* this should not happen */
		  errex(SWERR,"setvars");
	}
	if (viewonly) {
		bufstate = br + rowpage - 1;
		bufletter = bc + colpage - 1;
	}
	/* second: compute the screen position of (bufstate,bufletter)
	 * e.g. the logical row for bufstate is the distance between
	 * the upperleft corner state and bufstate
	 * the pysical row (scrrow) is computed with a factor rowjump
	 * and the offset STARTROW
	 */
	scrrow = rowjump*(bufstate-br+1) + STARTROW;
	scrcol = coljump*(bufletter-bc+1) + STARTCOL;
} /* setvars */

/******************************************************************/
static void
detboard(dir)
char dir;
/* build-up the screen
 * dir is the direction indicator; dir == 'i': initialization
 */
{ int c,r,row,col;
  posint s;
  /* row and col store the logical row and column number; c and r contain
   * the physical (screen) row and column number
   */
  short int ncount;	/* no of elements shown in a nfa-statelist */
	
	setvars(dir);
	clear();

	/* print the state- and the letterline */
	if (nondet)
		maketitle(TRUE,"N F A   T R A N S I T I O N T A B L E");
	else
		maketitle(TRUE,"D F A   T R A N S I T I O N T A B L E");
	mvaddstr(INFOROW,STARTCOL,"Number of states: ");
	addstr(pi2a(stateno+1));
	mvaddstr(INFOROW,STARTCOL+30,"Number of letters: ");
	addstr(pi2a(letterno));

	c = STARTCOL+coljump;
	col = 1;
	if (bc) col=0;
	else { mvaddch(STARTROW,c,epsch);
	       c += coljump;
	}
	for(; col < colpage; c+=coljump, col++)
		if (letterno <=  ALPHSIZE) /* lowercase letters are symbolnames */
			mvaddch(STARTROW,c,itoc[bc+col]);
		else {  mvaddch(STARTROW,c,'a');
			mvaddstr(STARTROW,c+1,pi2a(bc+col));
		}
	for(r = STARTROW+rowjump, row=0; row < rowpage; r+=rowjump, row++) {
		/* mark the initial state(s) with an '*' and the
		 * final states with a capital 'Q'
		 */
		if(nondet)
		  {mvaddch(r,STARTCOL-1,(isinit(infin[br+row])? '*':' '));
		   mvaddch(r,STARTCOL,(isfinal(infin[br+row])? 'Q':'q'));
                  }
                else 
		  {mvaddch(r,STARTCOL-1,(init==(br+row))? '*':' ');
		   mvaddch(r,STARTCOL,(infin[br+row])? 'Q':'q');
                  }
		mvaddstr(r,STARTCOL+1,pi2a(br+row));
	}

	/* fill the area with the known transitions */
	if (nondet) {	/* a nondeterministic automaton */
	     for(r = STARTROW+rowjump, row=0; row < rowpage; r+=rowjump, row++)
	      for(c = STARTCOL+coljump, col=0; col < colpage; c+=coljump, col++)
              {
		move(r,c);
		ncount = 0;   /* length of list of shown states */
		for(s=0; s<=stateno; s++)
		   if (testcon(nbuffer,bc+col,br+row,s)) {
			if (ncount) addch(',');
			if (++ncount == MAXNDSPLIT) { /* asterix represents rest */
			   addch('*'); ncount = 0; break;
			} else {
			   addch('q'); addstr(pi2a(s));
               }    }   }
	} else {	/* a deterministic automaton */
	     for(r = STARTROW+rowjump, row=0; row < rowpage; r+=rowjump, row++)
	      for(c = STARTCOL+coljump, col=0; col < colpage; c+=coljump, col++)
		if (dbuffer[bc+col][br+row] <= stateno) {
			mvaddch(r,c,'q');
			mvaddstr(r,c+1,pi2a(dbuffer[bc+col][br+row]));
		}
	}
	howtouse();
} /* detboard */

/******************************************************************/
static void
initscrvars()
/* initialize the screen variables */
{
	/*
	 * xxxmin == startxxx + xxxjump
	 * xxxmax must be of the form startxxx+n*xxxjump
	 * xxxpage is the number of xxx's pro page
	 * but it is limited by the number of neccessary xxx's
	 */
	rowmin = STARTROW + rowjump;
	rowmax = ((LINES - ROWSUB)/rowjump)*rowjump;
	rowmax += (STARTROW - rowjump); 
	colmin = STARTCOL + coljump;
	colmax = ((COLS - COLSUB)/coljump)*coljump;
	colmax += (STARTCOL - coljump);
	rowpage = (rowmax - rowmin)/rowjump + 1;
	colpage = (colmax - colmin)/coljump + 1;
	if (rowpage > stateno) rowpage =  stateno+1;
	if (colpage > letterno) colpage = (startlet)? letterno : letterno+1;
} /* initscrvars */

/******************************************************************/
static void
showtr()
/* show the complete statelist of a nondeterministic automaton */
{ posint s;	/* runs through all states */
  int row,col;	/* screen position */
  char ch;

	cleartut();
	if (viewonly) {
		addstr("Show the transition list of q"); refresh();
		gtyx(stdscr,row,col);
		do s = rdpnum(TRUE,row,col);
		while (s > stateno);
		bufstate = s;
		mvaddstr(row+1,LRCOL,"with letter "); refresh();
		gtyx(stdscr,row,col);
		if (letterno <= ALPHSIZE)  {
			do ch = getch();
			while ((ch < itoc[startlet]) || (ch > itoc[letterno])) ;
			addch(ch);refresh();
			if (ch == itoc[0]) bufletter = 0;
			else bufletter = ch - 'a' +1;
		} else {
			addch('a'); refresh();
			do s = rdpnum(TRUE,row,col+1);
			while ((s < startlet) || (s > letterno));
			bufletter = s;
		}
	}
	sleep(1); cleartut();
	for(s=0; s<=stateno; s++)
		if (testcon(nbuffer,bufletter,bufstate,s)) {
			addch('q'); addstr(pi2a(s)); addch(' ');
			gtyx(stdscr,row,col);
			if (col > COLS-6) { /* reaching the border */
		        	if (row++ != LINES-2) move(row,LRCOL);
		        	else { mvaddstr(row,LRCOL,"--- MORE ---");
					move(scrrow,scrcol); refresh();
					(void)getch(); cleartut();
       	 	}	}  	}	
	gtyx(stdscr,row,col);
	if (row != LINES-1) {
		mvaddstr(row+1,LRCOL,"END: Transitions of (q");
		addstr(pi2a(bufstate)); addch(',');
		if (letterno <= ALPHSIZE) addch(itoc[bufletter]);
		else {	addch('a'); addstr(pi2a(bufletter)); }
		addstr("); please press a key to continue");
		refresh();
                getch();
     	}
} /* showtr */

/******************************************************************/
static void
addel(addfl)
boole addfl;
/* add or delete a state from a nondeterministic statelist
 * addfl TRUE iff add state
 */
{ int row,col; 		/* screen position */
  int ncount;		/* number of states in list */
  posint s;		/* element to add or delete */

	cleartut();
	if (addfl) addstr("Add a state to the transition list of (q");
	else addstr("Delete a state from the transition list of (q");
	addstr(pi2a(bufstate)); addch(',');
	if (letterno <= ALPHSIZE) addch(itoc[bufletter]);
	else {  addch('a'); addstr(pi2a(bufletter)); }
	addstr("): q"); gtyx(stdscr,row,col);
	refresh();

	s = rdpnum(TRUE,row,col);

	/* show new list */
	if (s <= stateno) 
            {
	     if (addfl) connect(nbuffer,bufletter,bufstate,s);
	     else disconnect(nbuffer,bufletter,bufstate,s);
	     move(scrrow,scrcol);
	     for(ncount=coljump; ncount; ncount--) addch(' ');
	     move(scrrow,scrcol);
	     ncount = 0;   /* length of list of shown states */
	     for(s=0; s<=stateno; s++)
		  if (testcon(nbuffer,bufletter,bufstate,s)) 
                      {
		       if (ncount) addch(',');
		       if (++ncount == MAXNDSPLIT) 
                          { addch('*'); ncount = 0; break; /* asterix represents rest */ } 
                       else 
                          { addch('q'); addstr(pi2a(s)); }    
                      }
            } 
        else 
            {
             cleartut();
             mvaddstr(LASTROW+1,LRCOL,"No valid state!");
             refresh();
             sleep(1);
            }
} /* addel */

/******************************************************************/
static void
edloop(nofinal,noinit)
posint nofinal, noinit;
/* the editor-loop for automaton input
 * nofinal is the number of final states
 * noinit is the number of initial states
 */
{ char ch;
  int r, row;
  neuchar = 'X';
	for(;;) {
		/* move the cursor */
		if (!viewonly) move(scrrow,scrcol);
		refresh();	/* show the new screen */
                if(neuchar != 'X')
                   {ch=neuchar;neuchar='X';}
                else
                    ch=getch();
		switch(ch) {
		          /* the form of the direction actions:
			   *     close input procedure
			   *     check if aut. is only displayed
			   *     YES show new section with detboard
			   *	 NO  check if one step is possible
			   *	     YES do step
			   *	     check if screen shows step
			   *	     NO  show new section with detboard
			   */
		case 'h': /* move left one column */
		case 'H': if ((viewonly) && (bufletter+(1-startlet) > colpage))
				detboard('h');
			  else if (bufletter > startlet)  {
			  	bufletter--;
			  	if (scrcol > colmin) scrcol-=coljump;
			  	else /* a new page is needed */
					detboard('h');
			  }
			  break;
		case 'j': /* move down one row */
		case 'J': if ((viewonly) && (bufstate < stateno))
				detboard('j');
			  else if (bufstate < stateno) {
			  	bufstate++;
				if (scrrow < rowmax) scrrow+=rowjump;
			  	else /* a new page is needed */
					detboard('j');
			  }
			  break;
		case 'k': /* move up one row */
		case 'K': if ((viewonly) && (bufstate+1 > rowpage))
				detboard('k');
			  else if (bufstate) {
				bufstate--;
				if (scrrow > rowmin) scrrow-=rowjump;
				else /* a new page is needed */
					detboard('k');
			  }
			  break;
		case 'l': /* move right one column */
		case 'L': if ((viewonly) && (bufletter < letterno))
				detboard('l');
			  else if (bufletter < letterno) {
				bufletter++;
				if (scrcol < colmax) scrcol+=coljump;
				else /* a new page is needed */
					detboard('l');
			  }
			  break;
		case 'g': /* goto */
		case 'G': detboard('g');
			  break;
		case '0': 
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9': if (!viewonly) input(ch); /* input allowed */
			  break;
		case 'f': /* mark or unmark final */
		case 'F': if (viewonly) break; /* no change allowed */
			  if (isfinal(infin[bufstate])) {
				mvaddch(scrrow,STARTCOL,'q'); nofinal--;
			  } else {
				mvaddch(scrrow,STARTCOL,'Q'); nofinal++;
			  }
			  setfinal(infin[bufstate],!isfinal(infin[bufstate]));
			  break;
		case 'i': /* mark initial */
		case 'I': if (viewonly) break;  /* no change allowed */
			  if(nondet)  /* switch initial */
                            {if(isinit(infin[bufstate])) 
                               {mvaddch(scrrow,STARTCOL-1,' ');
				rminit(infin[bufstate]);
				noinit--;
			       } 
                             else 
                               {mvaddch(scrrow,STARTCOL-1,'*');
				setinit(infin[bufstate]);
				noinit++; 
			       }
                            } 
                          else 
                            {if((noinit) &&(init != bufstate))
                               {/* an initial state known */
			        /* search for this state on the screen */
				r = STARTROW + rowjump; row = 0;
				for(; row < rowpage; r += rowjump, row++)
				  if(br + row == init) 
                                    {/* delete its mark */
				     mvaddch(r,STARTCOL-1,' ');
				     break;
			            }
                               }
			      /* put new mark on current row */
			      mvaddch(scrrow,STARTCOL-1,'*');
			      init = bufstate; noinit = 1;
			     } 
                          break;
		case 'q': /* quit */
		case 'Q': if (viewonly) return;
			  cleartut();
			  /* make sure that an initial state has been defined
			   * inform user if no final state defined
			   * confirm the quitting
			   */
			  if(!noinit) 
                            {addstr("You must mark one state as an initial state.");
                             refresh();sleep(1);howtouse();
			    } 
                          else 
                            {if (!nofinal) addstr("No final state defined. ");
			     addstr("REALLY quit? (y/n) ");
			     refresh(); ch = getch();
			     if ((ch == 'y') || (ch == 'Y')) return;
                             else                            howtouse();
			    } 
                          break;
		case 's': /* show all transitions */
		case 'S': if (nondet) showtr();  /* only for nfa's */
			  howtouse();
			  break;
		case ',': 
		case 'a': /* add a state */
		case 'A': if ((viewonly) || (!nondet)) break;
			  addel(TRUE);
                          howtouse(); 
			  break;
		case 'd': /* delete a state */
		case 'D': if ((viewonly) || (!nondet)) break;
			  addel(FALSE);
                          howtouse(); 
			  break;
		default: /* wrong action, do nothing */
			  break;
		}
	}
} /* edloop */

/******************************************************************/
/******************************************************************/
posint
edit(buf1,buf2,inf,sm,lm,stl,in,view,nd)
posint **buf1;
boole ***buf2;
mrkfin inf;
posint sm,lm,stl,in;
boole view,nd;
/* invoke an editor for the input of a (non)deterministic automaton 
 * buf1 or buf2 is the working area
 * sm and lm are the dimensions
 * inf marks the initial and final states
 * stl is the first letter
 * init represents the initial state for deterministic automata
 * view is TRUE iff the automaton is only displayed
 * nd is TRUE iff it is a nondeterministic automaton
 * RETURN: the initial state
 */
{ int r;
  posint nofinal = 0;   /* no of final states */
  posint noinit = 0;	/* no of initial states */
  nondet = nd;
  infin=inf;
  init=in;
  viewonly=view;
  if (nondet) nbuffer = buf2;
  else dbuffer = buf1;
  /* if an automaton is already put in the buffer
   * count the number of final and initial states
   */
  if(nondet) 
    {for(r=0; r<=sm; ) 
       {noinit += (isinit(infin[r]))? 1 : 0;
        nofinal += (isfinal(infin[r++]))? 1 : 0;
       }
    } 
   else 
    {for(r=0; r<=sm; )
        nofinal += (infin[r++])? 1 : 0;
     if (init <= sm)noinit = 1;
    }

  /* initialize the variables */
  rowjump = STDROWJUMP;
  coljump = (nondet)?STDNCOLJUMP:STDDCOLJUMP;
  stateno = sm;
  letterno = lm;
  startlet = stl;
  initscrvars();
  /* build-up the screen */
  detboard('i');
  edloop(nofinal,noinit);
  return init;
} /* edit */
