/* edline.c 3.0 (KIEL) 11.94 */

#include "ext.h"

/* functions included:
 *
 *	static	boole knowname
 *
 *		void  rdref
 *		void  rdnam
 *		void  rdpnum
 */

/******************************************************************/
/******************************************************************/
static boole
knowname(str)
char *str;
/* checks if a language str already exists */
{ int i;
	for(i=0; i < maxidx; )
		if (!strcmp(str,langs[i++]->name)) return TRUE;
	return FALSE;
} /* knowname */

/******************************************************************/
/******************************************************************/
void
rdref(row,col,str,erow,ecol)
int row,col,erow,ecol;
char* str;
{ int count; /* counts the length of input, needed for screen pos */
  char ch;     /* last character typed in */
  boole cont;
	do {	move(row,col); clrtoeol(); refresh(); /* clear rest of input line */
		cont = FALSE;
		count = 0;
		for(;;) {      /* leave with break */
			ch = getch();  
			if ((ch == BACKSPACE) && (count)) {  /* go back */
				count--;
				mvaddch(row,col+count,' '); move(row,col+count);
				refresh();
			}	
			if ((count > REFLEN) || ((ch != ' ') && (isspace(ch)))) { /* end input */
				str[count] = '\0'; break; }
			if (isprint(ch)) {	/* valid char */
				addch(ch); str[count++] = ch; refresh(); }
		}
		move(erow,ecol); clrtoeol(); refresh(); /* clear errorline */
		if (count > REFLEN) {  /* overfull string */
			mvaddstr(erow,ecol,"Error: name to long. Type another name."); cont = TRUE;}
	} while (cont);
} /* rdref */

/******************************************************************/
void
rdnam(row,col,str,erow,ecol)
int row,col,erow,ecol;
char* str;
/* reads from screenpos (row,col) a name
 * error messages are printed at (erow,ecol)
 */
{ boole cont;  /* flag TRUE iff wrong input */
  int count; /* counts the length of input, needed for screen pos */
  char ch;     /* last character typed in */
	do {	move(row,col); clrtoeol(); refresh(); /* clear rest of input line */
		cont = FALSE;  /* all OK */
		count = 0;
		for(;;) {      /* leave with break */
			ch = getch();  
			if ((ch == BACKSPACE) && (count)) {  /* go back */
				count--;
				mvaddch(row,col+count,' '); move(row,col+count);
				refresh();
			}	
			if ((count > NLEN) || (isspace(ch))) { /* end input */
				str[count] = '\0'; break; }
			if (isalnum(ch)) {	/* valid char */
				addch(ch); str[count++] = ch; refresh(); }
		}
		move(erow,ecol); clrtoeol(); refresh(); /* clear errorline */
		if (!count)  {  /* empty string */
			mvaddstr(erow,ecol,"Error: empty word. Type another name."); cont = TRUE; }
		if (count > NLEN) {  /* overfull string */
			mvaddstr(erow,ecol,"Error: name to long. Type another name."); cont = TRUE;}
		if (knowname(str)) { /* test if name is known */
			mvaddstr(erow,ecol,"Error: name already known. Type another name."); cont = TRUE; }
	} while (cont);
} /* rdnam */

/******************************************************************/
posint
rdpnum(too0,row,col)
int row,col;
boole too0;
/* reads from screenpos (row,col) a number
 * too0 TRUE iff 0 is allowed
 * RETURN: the number
 */
{ posint res;
  int count,i;
  char ch;
  char str[PILEN+2];

	do {
		count = 0;
		move(row,col); clrtoeol(); refresh();
		for(;;) {
			ch = getch();
                        if ((ch == '0') && (!count)) 
                           {
                            addch(ch);
                            refresh();
                            break;  /* avoid input 000 */
                           }
			if ((ch == BACKSPACE) && (count)) {  /* go back */
				count--;
				mvaddch(row,col+count,' '); move(row,col+count);
				refresh();
			}
			if (count == PILEN) { str[--count] = '\0'; break; }
			if ((count) && (isspace(ch))) { str[count] = '\0'; break; }
			if (isdigit(ch)) { addch(ch); str[count++] = ch; refresh(); }
		}
		res = 0;
		for(i=0; i < count;) res=10*res + (str[i++] -'0');
		if ((!too0)  && (res)) too0 = TRUE;
	} while (!too0);
	return res;
} /* rdpnum */
