#ifndef EXTBIS_H
#define EXTBIS_H

/*
   Bordeaux : 1995
   */


/* -------------------------------- types.h ---------------------------------- */

/* type for a word : not an array of char but an array of identifiers of the 
   letters */
typedef posint *fa_word;

/* --------------------------------- cons.h ---------------------------------- */

/* corresponding to the new window UNARY OPERATION 2 */
#define U2WIN           'R'              

/* mark the end of a (char *) */
#define END_OF_STRING '\0'

/* for theuse of the following  macros see the files fa_word.h and fa_word.c */
/* mark the end of af variable of the fa_word type */
#define END_OF_FA_WORD -1
/* fa_word corresponding to the empty word */
#define EPS_FA_WORD 0 
/* vfa_word corresponding to a word of the empty language */
#define EMPTY_LANGUAGE_FA_WORD -2
/* "length" of EPS_FA_WORD (used by fa_word_len) */
#define EPS_FA_WORD_LEN 0
/* "length" of EMPTY_LANGUAGE_FA_WORD (used by fa_word_len) */
#define EMPTY_LANGUAGE_FA_WORD_LEN -1
/* Posint indetifiers corresponding to SEPARATOR1 and SEPARATOR2 for 
   the type fa_word */
#define PI_SEPARATOR1 -3
#define PI_SEPARATOR2 -4


/* For the operation stack (see codetests.h or win_una2.h for the references) */
#define stackch '#'


/* Value by default for the field word_not_code of a language if this
   field was not computed */
#define  WORD_NOT_CODE_DEFAULT "Not searched"
/* Value for the field word_not_code of a language if this language is a code */
#define  WORD_CODE_TRUE   "This language is a code"
/* Value for the field word_not_code of a language if epsilon is in this 
   language */
#define  EPS_IN_DFA "This language is not a code because epsilon belongs to the language."

/* Separators for the factors of the two factorisations in the field 
   word_not_code */
#define SEPARATOR1 '>'
#define SEPARATOR2 '<'

/* --------------------------------- ext.h ----------------------------------- */

/* Boolean that is used to manage the display of the window unaRy operation 2 */
boole una2operations; 


/* -------------------------------- error.h ---------------------------------- */

/* this function free the resources used, init the clock, and go back 
   to the main loop of the program in case of an interruption, corresponding to
   the _FLAG_ parameter */
#define free_resources(_FLAG_) \
{ \
    buffree(); freebuf(); \
    clock_reset(); \
    (void) longjmp(env, (_FLAG_)); \
}

#endif 



