/* keybrd.c 3.01 (KIEL) 02.95, oma */

#include "ext.h"

#include "extbis.h"   /* --- Bordeaux : 1995 --- */
#include "propcode.h" /* --- Bordeaux : 1995 --- */
#include "win_una2.h" /* --- Bordeaux : 1995 --- */

/* functions included:
 *
 *	static	boole evalcom()
 *	static	void  evalexp()
 *	static  void  evalaut()
 *	static	void  evalmon()
 *	static  void  evallan()
 *	static	void  evalone()
 *	static  void  twodata()
 *	static  void  evaltwo()
 *	static  void  evaluna()
 *	static  void  evalbin()
 *
 *		void  evalkey()
 */

/* functions Bordeaux 1995 
   static evaluna2() : window UNARY OPERATIONS2
*/

#define langknown 	if (!maxidx) {\
			help(FALSE,"Sorry, no language defined. Quit.");\
			} else

/* ONLY_IND, ONLY_NAM, IND_NAM values for unary and binary operations:
 *	get a language by index, enter a name for a new language, or both
 */

#define ONLY_IND	0
#define ONLY_NAM	1
#define IND_NAM	 	2

/******************************************************************/

/* --- Bordeaux : 1995 : start --- */

static boole twodata(boolx, language *, language *);

static void evaluna2()
/* This function manages the rest of the Unary Operation window */
{
  language l1, l2;
  char     curnum;

  menu = ASSIGNMENU;
  una2operations = TRUE;
  drawmenu(ASSIGNMENU);          
  help(FALSE,"UNARY OPERATIONS 2 : enter number to select");
  curnum = getch();

  switch(curnum)
    {
    case '1': 
      compmdfa();	  	  
      compnfa();
      help(FALSE,"Verify that this language is a sub-monoid");
      if( fa_utils_test_sub_monoid(curlan->ldfa, curlan->lnfa) == FALSE )
	help(TRUE,"This language is not a submonoid. Press a key.");
      else
	if(twodata(ONLY_NAM, &l1, &l2))
	  {
	    help(FALSE,"UNARY OPERATION 2 : create root of the language");
	    l2->ldfa = win_una2_root(curlan->ldfa, curlan->lnfa);
	    l2->bdfa = TRUE;
	    curidx = maxidx++;
	    curlan = langs[curidx];
	    curlan->inputis = DFAINP;	  
	    help(FALSE,"UNARY OPERATION 2 : create root of the language. Done");
	  }
      break;
    case '2': 
      if(twodata(ONLY_NAM, &l1, &l2))
	{
	  help(FALSE,"UNARY OPERATION 2 : create free hull of the language");
	  compmdfa();
	  compmnfa();
	  l2->ldfa = win_una2_free_hull(curlan->ldfa, curlan->lnfa);
	  l2->bdfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = DFAINP;	  
	  help(FALSE,"UNARY OPERATION 2 : create free hull of the language. Done");
	}
      break;
    case '3':
      if(twodata(ONLY_NAM, &l1, &l2))
	{
	  help(FALSE,"UNARY OPERATION 2 : create stack language");
	  compmdfa(); 
	  l2->ldfa = win_una2_stack(curlan->ldfa);
	  l2->bdfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = DFAINP;
	  help(FALSE,"UNARY OPERATION 2 : create stack language. Done");
	}
      break;      
    default :			/* wrong number, do nothing */
      help(FALSE,"UNARY OPERATION 2 : not a legal number");
    }

  una2operations = FALSE;       
  drawmenu(ASSIGNMENU);  
}
/* --- Bordeaux : 1995 : end --- */



/******************************************************************/
static boole
evalcom(curnum)
     char curnum;
/* choose an action 
 * INPUT:  curnum : commandno
 * RETURN: TRUE iff exit
 */
{ 
  char name[NLEN+5];
  char ch;
	
  switch(curnum)
    {
    case '1':	
      loadlan(TRUE,name); 
      break;
    case '2':	
      if(menu != LANGMENU)
	drawmenu(menu=LANGMENU);
      createlan();
      break;
    case '3':
      if(menu != LANGMENU)
	drawmenu(menu=LANGMENU);
      modify(); 
      break;
    case '4':
      deletelan(); 
      break;
    case '5':
      if (menu != LANGMENU)
	drawmenu(menu=LANGMENU);
      print();
      break;
    case '6':	
#ifdef NODISPLAY
      help(FALSE,"DISPLAY available on SUN-computer only");
#endif
#ifdef DISPLAY
      if (menu != LANGMENU)
	drawmenu(menu=LANGMENU);
      display(); 
#endif
      break;
    case '7':
      switch(menu)
	{
	case LANGMENU: 
	  menu = TESTMENU;
	  break;
	case TESTMENU: 
	  menu = ASSIGNMENU;
	  break;
	case ASSIGNMENU:
	  menu = LANGMENU;
	  break;
	default: 
	  errex(SWERR,"evalcom");
	}
      drawmenu(menu); break;
    case '8':	
      switch(menu)
	{
	case LANGMENU: 
	  menu = ASSIGNMENU;
	  break;
	case TESTMENU: 
	  menu = LANGMENU;
	  break;
	case ASSIGNMENU:
	  menu = TESTMENU;
	  break;
	default: 
	  errex(SWERR,"Evalcom");
	}
      drawmenu(menu); break;
    case '9':
      savelan(); 
      break;
    case '0':	
      help(FALSE,"Do you really want to quit? (y/n) ");
      ch = getch();
      if ((ch == 'y') || (ch == 'Y')) 
	{
	  help(FALSE,"Goodbye"); 
	  return TRUE;
	} 
      else  help(FALSE,"O.k. we go on!");
      break;
    default :			/* wrong choice, do nothing */
      help(FALSE,"COMMAND: not a legal command");
    }
  switch(menu) 
    {
    case TESTMENU: 
      updatewin(OWIN); 
      updatewin(TWIN); 
      break;
    case LANGMENU:
    case ASSIGNMENU: 
      break;
    }
  
  return FALSE;
} /* evalcom */

/******************************************************************/
static void
evalexp(curnum)
     char curnum;
     /* show an expression 
      * INPUT curnum: number of expr. representation
      * NO RETURN
      */
{	
  switch(curnum)
    {
    case '1': 
      showregx(); 
      break;
    case '2': showgenregx(); 
      break;
    case '3': showsfx(); 
      break;
    default : /* wrong number, do nothing */
      help(FALSE,"EXPRESSION: not a legal number");
    }
} /* evalexp */

/******************************************************************/
static void
evalaut(curnum)
     char curnum;
{	
  switch(curnum)
    {
    case '1': 
      help(FALSE,"AUTOMATA: computing the deterministic finite automaton.");
      showdfa(); 
      break;
    case '2':
      help(FALSE,"AUTOMATA: computing the nondeterministic finite automaton.");
      shownfa(); 
      break;
    case '3':
      help(FALSE,"AUTOMATA: computing the epsilon-nondeterministic finite automaton.");
      showeps(); 
      break;
    case '4':
      help(FALSE,"AUTOMATA: computing the minimal deterministic finite automaton.");
      showmdfa(); 
      break;
    case '5':
      help(FALSE,"AUTOMATA: computing a minimal nondeterministic finite automaton.");
      showmnfa(); 
      break;
    default : /* wrong number, do nothing */
      help(FALSE,"AUTOMATA: not a legal number");
    }
} /* evalaut */

/******************************************************************/
static void
evalmon(curnum)
     char curnum;
{	
  switch(curnum)
    {
    case '1': help(FALSE,"MONOID: computing the syntactic monoid.");
      showmon(); 
      break;
    case '2': 
      help(FALSE,"MONOID: computing Green's relations.");
      showdclasses(); 
      break;
    case '3': 
      help(FALSE,"MONOID: computing the multiplication table.");
      showmult();
      break;
    default : /* wrong number, do nothing */
      help(FALSE,"MONOID: not a legal number");
    }
} /* evalmon */

/******************************************************************/
static void
evallan(curnum)
     char curnum;
{	
  if ((curnum <= '9') && (curnum > '0')) 
    {
      /* curnum is a nonzero digit */
      if (curnum - '0' <= maxidx) /* curnum points to a def.language */
	chgelan(curnum -'1');
      else 
	help(TRUE,"No language with this number defined. Press a key to continue.");
  } 
  else /* wrong choice, do nothing */
    help(FALSE,"LANGUAGE: not a legal number");
} /* evallan */

/******************************************************************/
static void
evalone(curnum)
     char curnum;
{
  boole test; /* to avoid wrong setings if prozedure (testdd1) is killed */
	
  switch(curnum)
    {
    case '1': 
      if (curlan->folu == UN_KNOWN) 
	{
	  help(FALSE,"ONE LANGUAGE: test if in FOLU");
	  compmdfa();
	  test=folutest(curlan->ldfa); 
	  curlan->folu=test;
	  curlan->saved = FALSE;
	}
      break;
    case '2': 
      if (curlan->starfree == UN_KNOWN) 
	{
	  help(FALSE,"ONE LANGUAGE: test if starfree");
	  compmon();
	  test=sftest(curlan->lmon);
	  curlan->starfree=test;
	  if(curlan->starfree)
	    curlan->folu=TRUE;
	}
      break;
    case '3': 
      if ((curlan->bmon) && (curlan->starfree == TRUE)) 
	{
	  if (curlan->dotdepth1 != UN_KNOWN) 
	    break;
	  help(FALSE,"ONE LANGUAGE: test dotdepth");
	  test= testdd1(curlan->lmon); 
	  curlan->dotdepth1=test; 
	  curlan->saved = FALSE; 
	  break;
	}
    case '4': 
      if ((curlan->bmon) && (curlan->starfree == TRUE)) 
	{
	  if (curlan->definite != UN_KNOWN) 
	    break;
	  help(FALSE,"ONE LANGUAGE: test definit properties");
	  proptest(curlan,curlan->lmon); 
	  curlan->saved = FALSE; 
	  break;
	}
    case '5': 
      if ((curlan->bmon) && (curlan->starfree == TRUE)) 
	{
	  if (curlan->piecetest != UN_KNOWN) 
	    break;
	  help(FALSE,"ONE LANGUAGE: test if piecewise testable");
	  test=testpwt(curlan->lmon);
	  curlan->piecetest=test; 
	  curlan->saved = FALSE; 
	  break;
	}
    case '6':                                    /* --- Bordeaux : 1995  --- */
      compmnfa();                                /* --- Bordeaux : 1995  --- */
      compmdfa();                                /* --- Bordeaux : 1995  --- */
      help(FALSE,"Code properties");             /* --- Bordeaux : 1995  --- */
      propcode_all_codes(curlan);                /* --- Bordeaux : 1995  --- */
      help(FALSE,"Code properties : done");      /* --- Bordeaux : 1995  --- */
      break;                                     /* --- Bordeaux : 1995  --- */
    default : /* wrong number, do nothing */
      help(FALSE,"ONE LANGUAGE: not a legal number");
    }
  updatewin(OWIN);
} /* evalone */

/******************************************************************/
static boole
twodata(two,l2,l3)
     boolx two;
     language *l2,*l3;
     /* if two == ONLY_IND get an index of a defined language
      * if two == IND_NAM get an index of a def. language and get a name of a new language
      * if two == ONLY_NAM get a name of a new language
      * RETURN: l2,l3 the second resp. third language
      *
      * TRUE if successful defined
      * l2 = curlan!!
      */
{ 
  boole quit = FALSE;
  char idx2,ch,i;
  char name[NLEN+2];
  char ref[REFLEN+2];
  
  if((maxidx == NLANG) && (two != ONLY_IND)) 
    {
      help(FALSE," Please delete a language.");
      return FALSE;
    }

  if(two!= ONLY_NAM) 
    {
      do 
	{
	  help(FALSE,"L1 is marked; please enter number of L2 (0=quit)");
	  
	  do 
	    ch = getch(); 
	  while ((ch < '0')||(ch > '9')||((ch -'1') > maxidx));
	  
	  if (ch == '0') 
	    return FALSE;
	  idx2 = ch - '1';
	  *l2 = langs[idx2];
	  if((*l2)->sizeal != curlan->sizeal) 
	    help(TRUE,"L1 and L2 must have the same alphabet. Press key to continue.");
	  else 
	    quit = TRUE;
        } 
      while (!quit);

      curidx = idx2; 
      curlan = *l2;
      if(two == IND_NAM) 
	help(FALSE,"Please enter name of L3");
      else
	return TRUE;
    } 
  else
    help(FALSE,"L1 is marked; please enter name of L2");

  rdnam(INPROW,INPCOL+INPOFF,name,HELPROW,HELPCOL);
  help(FALSE,"Please enter reference string");
  rdref(INPROW,INPCOL+INPOFF,ref,HELPROW,HELPCOL);
  *l3 = newlang(maxidx);
  for(i=0; i<NLEN; i++) 
    (*l3)->name[i] = name[i];
  for(i=0; i<REFLEN; i++) 
    (*l3)->ref[i] = ref[i];
  (*l3)->sizeal = curlan->sizeal;
  return TRUE;
} /* twodata */

/******************************************************************/
static void
evaltwo(curnum)
     char curnum;
{ 
  language l1,l2,l3;
  boolx result;
  char oldidx;
	
  switch(curnum)
    {
    case '1':
      help(FALSE,"TWO LANGUAGES: test emptiness");
      result = empty_full_lan();
      if(result == TRUE)
	{
	  curlan->empty = FALSE; 
	  curlan->full=TRUE;
	}
      else 
	if (result == FALSE)
	  {
	    curlan->empty = TRUE; 
	    curlan->full= FALSE;
	  }
	else
	  {
	    curlan->empty = FALSE;
	    curlan->full= FALSE;
	  }
      break;
    case '2':
      help(FALSE,"TWO LANGUAGES: test A*");
      result = empty_full_lan();
      if(result == TRUE)
	{
	  curlan->empty = FALSE;
	  curlan->full=TRUE;
	}
      else 
	if (result == FALSE)
	  {
	    curlan->empty = TRUE;
	    curlan->full= FALSE;
	  }
	else
	  {
	    curlan->empty = FALSE;
	    curlan->full= FALSE;
	  }
      break;
    case '3':
      help(FALSE,"TWO LANGUAGES: equivalence test");
      compmdfa(); 
      l1 = curlan; 
      oldidx = curidx; 
      if(twodata(ONLY_IND,&l2,&l3)) /* l2 is curlan */
	{
	  help(FALSE,"TWO LANGUAGES: equivalence test");
	  compmdfa();
	  curlan = l1;
	  curidx = oldidx;
	  if(equiv(curlan->ldfa,l2->ldfa))
	    help(FALSE,"TWO LANGUAGES: Languages are equivalent");
	  else 
	    help(FALSE,"TWO LANGUAGES: Languages are not equivalent");
	}
      break;
    case '4':
      help(FALSE,"TWO LANGUAGES: inclusion test");
      l1 = curlan; 
      oldidx = curidx;
      compmdfa();
      if (twodata(ONLY_IND,&l2,&l3)) 
	{
	  help(FALSE,"TWO LANGUAGES: inclusion test");
	  compmdfa();
	  curlan = l1;
	  curidx = oldidx;
	  if (inclusion(curlan->ldfa,l2->ldfa,TRUE))
	    help(FALSE,"TWO LANGUAGES: Language L1 is contained in L2");
	  else 
	    help(FALSE,"TWO LANGUAGES: Language L1 is not contained in L2");
	}
      break;
    case '5': help(FALSE,"TWO LANGUAGES: test if languages are disjunct");
      l1 = curlan;
      oldidx = curidx; compmdfa();
      if (twodata(ONLY_IND,&l2,&l3)) 
	{
	  help(FALSE,"TWO LANGUAGES: test if languages are disjunct");
	  compmdfa();
	  curlan = l1; 
	  curidx = oldidx;
	  if (inclusion(curlan->ldfa,l2->ldfa,FALSE))
	    help(FALSE,"TWO LANGUAGES: Languages are disjunct");
	  else 
	    help(FALSE,"TWO LANGUAGES: Languages are not disjunct");
	}
      break;
    default : 
      help(FALSE,"TWO LANGUAGES: not a legal number");
    }
  updatewin(OWIN); updatewin(TWIN);
} /* evaltwo */

/******************************************************************/
static void
evaluna(curnum)
     char curnum;
{ 
  language l2,l3;
  switch(curnum)
    {
    case '1': 
      if (twodata(ONLY_NAM,&l2,&l3)) 
	{
	  help(FALSE,"UNARY OPERATION: create star language.");
	  compnfa();
	  l3->lnfa = starnfa(curlan->lnfa,FALSE);
	  l3->bnfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = NFAINP;
	  help(FALSE,"UNARY OPERATION: create star language. Done!");
	}
      break;
    case '2':
      if (twodata(ONLY_NAM,&l2,&l3)) 
	{
	  help(FALSE,"UNARY OPERATION: create plus language.");
	  compnfa();
	  l3->lnfa = starnfa(curlan->lnfa,TRUE);
	  l3->bnfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = NFAINP;
	  help(FALSE,"UNARY OPERATION: create plus language. Done!");
	}
      break;
    case '3':
      if (twodata(ONLY_NAM,&l2,&l3)) 
	{
	  help(FALSE,"UNARY OPERATION: create complement language.");
	  compmdfa();
	  l3->ldfa = compldfa(curlan->ldfa);
	  l3->bdfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = DFAINP;
	  help(FALSE,"UNARY OPERATION: create complement language. Done!");
	}
      break;
    case '4':
      if (twodata(ONLY_NAM,&l2,&l3)) 
	{
	  help(FALSE,"UNARY OPERATION: create reverse language.");
	  compnfa();
	  l3->lnfa = revnfa(curlan->lnfa);
	  l3->bnfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = NFAINP;
	  help(FALSE,"UNARY OPERATION: create reverse language. Done!");
	}
      break;
    case '5':
      if (twodata(ONLY_NAM,&l2,&l3)) 
	{
	  help(FALSE,"UNARY OPERATION: compute the minimal words.");
	  compmdfa();
	  l3->ldfa = minL(curlan->ldfa);
	  l3->bdfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = DFAINP;
	  help(FALSE,"UNARY OPERATION: compute the minimal words. Done!");
	}
      break;
    case '6':
      if (twodata(ONLY_NAM,&l2,&l3)) 
	{
	  help(FALSE,"UNARY OPERATION: compute the maximal words.");
	  compmdfa();
	  l3->ldfa = maxL(curlan->ldfa);
	  l3->bdfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = DFAINP;
	  help(FALSE,"UNARY OPERATION: compute the maximal words. Done!");
	}
      break;
    case '7':
      if (twodata(ONLY_NAM,&l2,&l3)) 
	{
	  help(FALSE,"UNARY OPERATION: compute the set of prefixes.");
	  compmdfa();
	  l3->ldfa = pref(curlan->ldfa);
	  l3->bdfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = DFAINP;
	  help(FALSE,"UNARY OPERATION: compute the set of prefixes. Done!");
	}
      break;
    case '8':
      if (twodata(ONLY_NAM,&l2,&l3)) 
	{
	  help(FALSE,"UNARY OPERATION: compute the set of suffixes.");
	  compmdfa();
	  l3->lnfa = suff(curlan->ldfa);
	  l3->bnfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = NFAINP;
	  help(FALSE,"UNARY OPERATION: compute the set of suffixes. Done!");
	}
      break;
    case '9':       /* --- Bordeaux : 1995 --- */
      evaluna2();   /* --- Bordeaux : 1995 --- */
      break;        /* --- Bordeaux : 1995 --- */
    default :
      help(FALSE,"UNARY OPERATION: not a legal number");
    }
  updatewin(LWIN);
} /* evaluna */

/******************************************************************/
static void
evalbin(curnum)
     char curnum;
{ 
  language l1,l2,l3;
  switch(curnum)
    {
    case '1':
      help(FALSE,"BINARY OPERATION: create union.");
      l1 = curlan;
      compnfa();
      if (twodata(IND_NAM,&l2,&l3)) 
	{
	  help(FALSE,"BINARY OPERATION: create union.");
	  compnfa();
	  l3->lnfa = unionfa(curlan->lnfa,l1->lnfa);
	  l3->bnfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = NFAINP;
	  updatewin(LWIN);
	  help(FALSE,"BINARY OPERATION: create union. Done!");
	}
      break;
    case '3':
      help(FALSE,"BINARY OPERATION: create concatenation.");
      l1 = curlan; compnfa();
      if (twodata(IND_NAM,&l2,&l3)) 
	{
	  help(FALSE,"BINARY OPERATION: create concatenation.");
	  compnfa();
	  l3->lnfa = concatfa(l1->lnfa,curlan->lnfa);
	  l3->bnfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = NFAINP;
	  updatewin(LWIN);
	  help(FALSE,"BINARY OPERATION: create concatenation. Done!");
		  }
      break;
    case '2': 
      help(FALSE,"BINARY OPERATION: create intersection.");
      l1 = curlan; 
      compmdfa();
      if (twodata(IND_NAM,&l2,&l3)) 
	{
	  help(FALSE,"BINARY OPERATION: create intersection.");
	  compmdfa();
	  l3->ldfa = insecfa(l1->ldfa,curlan->ldfa,FALSE);
	  l3->bdfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = DFAINP;
	  updatewin(LWIN);
	  help(FALSE,"BINARY OPERATION: create intersection. Done!");
	}
      break;
    case '4':
      help(FALSE,"BINARY OPERATION: create difference.");
      l1 = curlan;
      compmdfa();
      if (twodata(IND_NAM,&l2,&l3)) 
	{
	  help(FALSE,"BINARY OPERATION: create difference.");
	  compmdfa();
	  l3->ldfa = insecfa(l1->ldfa,curlan->ldfa,TRUE);
	  l3->bdfa = TRUE;
	  curidx = maxidx++; 
	  curlan = langs[curidx];
	  curlan->inputis = DFAINP;
	  updatewin(LWIN);
	  help(FALSE,"BINARY OPERATION: create difference. Done!");
	}
      break;
    case '5':
      help(FALSE,"BINARY OPERATION: create shuffle.");
      l1 = curlan; 
      compnfa();
      if (twodata(IND_NAM,&l2,&l3)) 
	{
	  help(FALSE,"BINARY OPERATION: create shuffle.");
	  compnfa();
	  l3->lnfa = shuffle(l1->lnfa,curlan->lnfa);
	  l3->bnfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = NFAINP;
	  updatewin(LWIN);
	  help(FALSE,"BINARY OPERATION: create shuffle. Done!");
	}
      break;
    case '6':
      help(FALSE,"BINARY OPERATION: create left quotient.");
      l1 = curlan; 
      compmdfa();
      if (twodata(IND_NAM,&l2,&l3)) 
	{
	  help(FALSE,"BINARY OPERATION: create left quotient.");
	  compmdfa();
	  l3->lnfa = leftquot(l1->ldfa,curlan->ldfa);
	  l3->bnfa = TRUE;
	  curidx = maxidx++;
	  curlan = langs[curidx];
	  curlan->inputis = NFAINP;
	  updatewin(LWIN);
	  help(FALSE,"BINARY OPERATION: create left quotient. Done! ");
	}
      break;
    case '7':
      help(FALSE,"BINARY OPERATION: create right quotient.");
      l1 = curlan;
      compmdfa();
      if (twodata(IND_NAM,&l2,&l3)) 
	{
	  help(FALSE,"BINARY OPERATION: create right quotient.");
	  compmdfa();
	  l3->ldfa = rightquot(l1->ldfa, curlan->ldfa);
	  l3->bdfa = TRUE;
	  curidx = maxidx++; 
	  curlan = langs[curidx];
	  curlan->inputis = DFAINP;
	  updatewin(LWIN);
	  help(FALSE,"BINARY OPERATION: create right quotient. Done!");
	}
      break;
    default :
      help(FALSE,"BINARY OPERATION: not a legal number.");
    }
} /* evalbin */

/******************************************************************/
void
evalkey()
/* evaluate the keystrokes */
{ 
  boole quit=FALSE;
  int switchvar;
	
  for(;!quit;) 
    {
      switchvar = (setjmp(env));
      catchsig();
      switch(switchvar) 
	{
	case 0: 
	  break;
	case 1: 
	  una2operations = FALSE;      /* --- Bordeaux : 1995 --- */
	  drawmenu(menu);
	  resettime();
	  help(FALSE,"Sorry cannot continue; operating system refuses to fetch more memory");
	  freebuf();
	  break;
	case 2: 
	  una2operations = FALSE;      /* --- Bordeaux : 1995 --- */
	  drawmenu(menu);
	  resettime();
	  help(FALSE,"Sorry cannot continue; system parameters are too small");
	  freebuf();
	  break;
	case 3:
	  una2operations = FALSE;      /* --- Bordeaux : 1995 --- */
	  drawmenu(menu);
	  resettime();
	  help(FALSE,"Computation stopped.");
	  freebuf();
	  break;
	default:
	  errex(JMPERR,"evalkey (setjmp)");
	}
      switch(menu)
	{
	case TESTMENU:
	  switch(getch())
	    {
	      /* --- Bordeaux : 1995 : start --- */
	    case 'r':
	    case 'R':
	      if ( maxidx == 0 )
		help(FALSE,"Sorry, no language defined");
	      else
		evaluna2();            
	      break;                         
	      /* --- Bordeaux : 1995 : end --- */
	    case 'G': /* command */
	    case 'g': 
	      help(FALSE,"COMMAND: Please enter number to select a command.");
	      quit = evalcom(getch()); 
	      break;
	    case 'O': /* one language */
	    case 'o': 
	      langknown 
		{
		  help(FALSE,"ONE LANGUAGE: Please enter number to test a property of marked language.");
		  evalone(getch()); 
		}
	      break;
	    case 'T': /* two languages */
	    case 't': 
	      langknown {
		help(FALSE,"TWO LANGUAGES: Please enter number to select action.");
		evaltwo(getch()); 
	      }
	      break;
	    case 'L': /* language */
	    case 'l': 
	      langknown 
		{
		  help(FALSE,"LANGUAGES: Please enter number to change the current language.");
		  evallan(getch()); 
		} 
	      break;
	    case 'u': /* unary op */ 
	    case 'U': 
	      drawmenu(menu=ASSIGNMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"UNARY OPERATION: Please enter number to select operation.");
		  evaluna(getch()); 
		}
	      break;
	    case 'b': /* binary op */ 
	    case 'B': 
	      drawmenu(menu=ASSIGNMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"BINARY OPERATION: Please enter number to select operation.");
		  evalbin(getch()); 
		}
	      break;
	    case 'a': /* automaton */ 
	    case 'A': 
	      drawmenu(menu=LANGMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"AUTOMATA: Please enter number to see an automaton.");
		  evalaut(getch());  
		} 
	      break;
	    case 'm': /* monoid */ 
	    case 'M': 
	      drawmenu(menu=LANGMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"MONOID: Please enter number to see the monoid structure.");
		  evalmon(getch());  
		}
	      break;
	    case 'e': /* expression */ 
	    case 'E': 
	      drawmenu(menu=LANGMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"REG. EXPRESSION: Please enter number to get a reg. expression.");
		  evalexp(getch());  
		}
	      break;
	    default:  /* no legal input, wait */
	      help(FALSE,"Please enter only one of the uppercase letters from the window headlines");
	    } 
	  break;
	case LANGMENU:
	  switch(getch())
	    {
	      /* --- Bordeaux : 1995 : start --- */
	    case 'r':
	    case 'R':
	      if ( maxidx == 0 )
		help(FALSE,"Sorry, no language defined");
	      else
		evaluna2();            
	      break;                        
	      /* --- Bordeaux : 1995 : end --- */ 
	    case 'G': /* command */
	    case 'g': 
	      help(FALSE,"COMMAND: Please enter number to select a command.");
	      quit = evalcom(getch()); 
	      break;
	    case 'E': /* expression */
	    case 'e': 
	      langknown 
		{
		  help(FALSE,"REG. EXPRESSION: Please enter number to get a reg. expression.");
		  evalexp(getch());  
		} 
	      break;
	    case 'A': /* automaton */
	    case 'a': 
	      langknown 
		{
		  help(FALSE,"AUTOMATA: Please enter number to see an automaton.");
		  evalaut(getch());  \
		}
	      break;
	    case 'M': /* monoid */
	    case 'm': 
	      langknown 
		{
		  help(FALSE,"MONOID: Please enter number to see the monoid structure.");
		  evalmon(getch());  
		}
	      break;
	    case 'L': /* language */
	    case 'l': 
	      langknown 
		{
		  help(FALSE,"LANGUAGES: Please enter number to change the current language.");
		  evallan(getch());
		} 
	      break;
	    case 'u': /* unary op */ 
	    case 'U': 
	      drawmenu(menu=ASSIGNMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"UNARY OPERATION: Please enter number to select operation.");
		  evaluna(getch());
		}
	      break;
	    case 'b': /* binary op */ 
	    case 'B': 
	      drawmenu(menu=ASSIGNMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"BINARY OPERATION: Please enter number to select operation.");
		  evalbin(getch());
		} 
	      break;
	    case 'o': /* one language */ 
	    case 'O': 
	      drawmenu(menu=TESTMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"ONE LANGUAGE: Please enter number to test a property of marked language.");
		  evalone(getch());
		} 
	      break;
	    case 't': /* two languages */ 
	    case 'T':
	      drawmenu(menu=TESTMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"TWO LANGUAGES: Please enter number to select action.");
		  evaltwo(getch()); 
		} 
	      break;
	    default:  /* no legal input, wait */
	      help(FALSE,"Please enter only one of the uppercase letters from the window headlines");
	    } 
	  break;
	case ASSIGNMENU:
	  switch(getch())
	    {
	      /* --- Bordeaux : 1995 : start --- */
	    case 'r':
	    case 'R':
	      if ( maxidx == 0 )
		help(FALSE,"Sorry, no language defined");
	      else
		evaluna2();            
	      break;                         
	      /* --- Bordeaux : 1995 : end --- */
	    case 'G': /* command */
	    case 'g': 
	      help(FALSE,"COMMAND: Please enter number to select a command.");
	      quit = evalcom(getch()); 
	      break;
	    case 'U': /* unary op */
	    case 'u':
	      langknown 
		{
		  help(FALSE,"UNARY OPERATION: Please enter number to select operation.");
		  evaluna(getch());
		} 
	      break;
	    case 'B': /* binary op */
	    case 'b': 
	      langknown 
		{
		  help(FALSE,"BINARY OPERATION: Please enter number to select operation.");
		  evalbin(getch()); 
		}
	      break;
	    case 'L': /* language */
	    case 'l': 
	      langknown 
		{
		  help(FALSE,"LANGUAGES: Please enter number to change the current language.");
		  evallan(getch());
		} 
	      break;
	    case 'a': /* automaton */ 
	    case 'A':
	      drawmenu(menu=LANGMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"AUTOMATA: Please enter number to see an automaton.");
		  evalaut(getch()); 
		}
	      break;
	    case 'm': /* monoid */ 
	    case 'M':
	      drawmenu(menu=LANGMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"MONOID: Please enter number to see the monoid structure.");
		  evalmon(getch());
		} 
	      break;
	    case 'e': /* expression */ 
	    case 'E': 
	      drawmenu(menu=LANGMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"REG. EXPRESSION: Please enter number to get a reg. expression.");
		  evalexp(getch()); 
		}
	      break;
	    case 'o': /* one language */ 
	    case 'O':
	      drawmenu(menu=TESTMENU); 
	      refresh();
	      langknown 
		{
		  help(FALSE,"ONE LANGUAGE: Please enter number to test a property of marked language.");
		  evalone(getch()); 
		}
	      break;
	    case 't': /* two languages */ 
	    case 'T':
	      drawmenu(menu=TESTMENU); refresh();
	      langknown 
		{
		  help(FALSE,"TWO LANGUAGES: Please enter number to select action.");
		  evaltwo(getch()); 
		} 
	      break;
	    default:  /* no legal input, wait */
	      help(FALSE,"Please enter only one of the uppercase letters from the window headlines");
	    }
	  break;
	default: /* this should not happen */
	  errex(SWERR,"EVALKEY");
	}	
    }
} /* evalkey */


