/* monoid.c 3.0 (KIEL) 11.94 */

#include "ext.h"

/* functions included:
 *		char *prword
 *              char* prword1
 *
 * 	       void compword()
 *             posint mult()
 *	       void comprestofmon()
 *             posint monmaxlen()
 *
 *             void multtable() 
 */
/******************************************************************/

#define newmonoid()		(monoid)newbuf((posint)1,(posint)sizeof(struct mono))

/******************************************************************/
char*
prword1(word,copy,length,no,mon,with,zeroone)
/* prword returns the shortest representative of the element no in monoid mon
 * if (copy) word contains a copy of the output
 * in this case length is the size of word
 * if (with) mark idempotent elements with a star
 * if (zeroone) print 0 for mon->zero else the representative of the zero
 *              print 1 for the identity else ""
 */
char **word;
boole copy,with,zeroone;
posint *length;
posint no;
monoid mon;
{ posint l,start;
  char dummy[2];
  compword(mon,no);
  dummy[1] = '\0';
  for(l=0;mon->repr[l]!='\0';l++)mon->repr[l]='\0';
  start=(with)? 1 : 0;
  if(with)
    if (no==mult(mon,no,no))mon->repr[0] = '*';
    else mon->repr[0]= ' ';
  if(no==0) /* special case identity */
    {if(zeroone)mon->repr[start]='1';}
  else if((no==mon->zero)&&(zeroone))  /* special case zero */
    mon->repr[start]='0';
  else if(mon->sno > 27) 
    for(l=0;l<mon->no2length[no];l++)
      {(void)strcat(mon->repr,"a");
       (void)strcat(mon->repr,pi2a(mon->generator[mon->word[l]]));
      } 
  else
    for(l=0;l<mon->no2length[no];l++)
      {dummy[0] = itoc[mon->generator[mon->word[l]]];
       (void)strcat(mon->repr,dummy);
      }
  /* copy mon->repr if copy is set */
  if(copy)
    {/* compute length of string */
     l=0;
     while(mon->repr[l]!='\0')l++;
     *length= ++l;
     (*word) = newstring(l);
     for(l=0;l<(*length);l++)
	(*word)[l]=mon->repr[l];
    }
  return mon->repr;
} /* prword1 */

/******************************************************************/
char* prword(no,mon,with)
posint no;
monoid mon;
boole with;
{
 return(prword1((char **)NULL,FALSE,(posint *)NULL,no,mon,with,TRUE));
}

/******************************************************************/
/******************************************************************/
void compword(mon,no)
/* store representative of no (as sequence of generators) in mon->word */
monoid mon;
posint no;
{
 posint letter,elem;
 elem=no;
 /* no2length = number of pred */
 for(letter=mon->no2length[no];letter!=0;)
   {
    mon->word[--letter]=mon->lastletter[elem];
    elem=mon->gensucc[elem][0];
   }
}
/******************************************************************/
posint mult(mon,a,b)
/* multiplication of 2 monoidelements a and b */
posint a,b;
monoid mon;
{register posint i;
 register posint help=a;
 compword(mon,b);
 for(i=0;i<mon->no2length[b];i++)
     help=mon->gensucc[help][mon->word[i]];
 return(help);
}

/******************************************************************/
void comprestofmon(mon,indfa)
/* known gensucc 
 * computes no2trans,gensucc[][0],no2length,lastletter for a computed monoid
 * O(mon->mno*mon->gno+mon->mno*mon->qno)
 */ 
monoid mon;
dfa indfa;
{posint state,elem,gen,run;
 /* get memory */
 mon->no2length=newar(mon->mno);
 mon->lastletter=newar(mon->mno);
 /* create the identity */ 
 for(state=0;state<=mon->qno;state++)
   mon->no2trans[0][state]=state;
 mon->gensucc[0][0]=0;
 mon->lastletter[0]=0;
 mon->no2length[0]=0;
 /* compute the transformations */
 run=1;
 for(elem=0;elem<mon->mno;elem++)
   for(gen=1;gen<=mon->gno;gen++)
     if(mon->gensucc[elem][gen]==run) /* elem is pred of run */
       {mon->gensucc[run][0]=elem;
        mon->lastletter[run]=gen;
        /* compute transformation */
        for(state=0; state<=mon->qno;state++)
          mon->no2trans[run][state]=indfa->delta[mon->generator[gen]][mon->no2trans[elem][state]];
        mon->no2length[run]=mon->no2length[elem]+1;
        run++;
       }
 mon->word=newar(mon->no2length[mon->mno-1]);
 gen=mon->no2length[mon->mno-1]+1;  /* number of letters of longest element +1 */
 gen *= (mon->sno<=27)? 1 : strlen(pi2a(mon->sno))+1;
 mon->repr=(string)calloc(gen,sizeof(char));
 for(state=0;state<gen;)mon->repr[state++]='\0';
}

/**************************************************************************/
posint monmaxlen(mon) 
/* compute length of longest representative of monoid mon */
monoid mon;
{
 posint maxlen,l;
 posint elem,gen;
 boole test;
 char* word;
 if(mon->zero!=mon->mno)
    (void)prword1(&word,TRUE,&maxlen,mon->zero,mon,TRUE,FALSE);
 else
    maxlen=1;
 /* compute all elements which have no successor of greater number */
 for(elem=0;elem<mon->mno;elem++)
   {test=TRUE;
    for(gen=1;gen<=mon->gno;gen++)
     if(elem==mon->gensucc[mon->gensucc[elem][gen]][0]) 
       {test=FALSE;break;}
	/* elem is pred of elem.gen in this case |elem.gen|>|elem| */
    if(test) /* compute length of elem */
      {l=strlen(prword(elem,mon,TRUE));
       maxlen=(maxlen>l)? maxlen : l;
      }
   }
 return(maxlen);
}

/**************************************************************************/
void multtable(mon,flag)
/* show (flag==TRUE) or print (flag==FALSE) the
 * multiplication table of mon
 */
boole flag; /* flag iff print multtable */
monoid mon;
{
 posint m1,m2;
 arrayofarray delta;
 monoid locmon;
 locmon=newmonoid();
 locmon->gno=mon->gno;
 locmon->sno=mon->sno;
 locmon->mno=mon->mno;
 locmon->lastletter=mon->lastletter;
 locmon->gensucc=mon->gensucc;
 locmon->no2length=mon->no2length;
 locmon->generator=mon->generator;
 locmon->let2gen=mon->let2gen;
 locmon->zero=mon->zero;
 locmon->word=mon->word;
 locmon->repr=mon->repr;
 delta=newarrayofarray(mon->mno);
 if(mon->mno<TABLESWITCH)
   {locmon->qno=mon->mno;
    for(m1=0;m1<mon->mno;m1++)
      delta[m1]=newarray(mon->mno+1);
    for(m1=0;m1<mon->mno;m1++)
       for(m2=0;m2<mon->mno;m2++)
          delta[m1][m2+1]=mult(mon,m1,m2)+1;
   }
 else
   {locmon->qno=mon->gno;
    for(m1=0;m1<mon->mno;m1++)
      delta[m1]=newarray(mon->gno+1);
    for(m1=0;m1<mon->mno;m1++)
       for(m2=1;m2<=mon->gno;m2++)
          delta[m1][m2]=mon->gensucc[m1][m2]+1;
   }
 /* first columne gives a number to all elements of the monoid */
 for(m1=0;m1<locmon->mno;m1++)
    delta[m1][0]=m1+1;
 locmon->no2trans=delta;
 if(flag) prtmon(locmon,TRUE);
 else     editmon(locmon,TRUE);
 freebuf();
}
