/* readamr.c 3.1 (KIEL) 01.95 */
#include "ext.h"

#include "extbis.h"    /* --- Bordeaux : 1995 --- */

extern char *versiontext[];

/* functions included:
 *
 *	static	int	a2i()
 *		posint	a2pi()
 *	static	boolx	a2bx()
 *	static	boole	a2be()
 *
 *	static	void	readstr()
 *	static	boole	rdinsf()
 *	static	boole	rdinrex()
 *	static	boole	rdinform()
 *	static	boole	rdindfa()
 *	static	boole	rdinnfa()
 *	static	boole	rdindcl()
 *	static	boole	rdinmon()
 *	      	boolx	rdinlan()
 */


static posint version; 

/******************************************************************/
/******************************************************************/
static int
a2i(str)
     char *str;
{ 
  int i;
  
  (void)sscanf(str,IFMT,&i);
  return i;
} /* a2i */

/******************************************************************/
posint
a2pi(str)
     char *str;
{ 
  posint pi;
	
  (void)sscanf(str,PIFMT,&pi);
  return pi;
} /* a2pi */

/******************************************************************/
static boolx
a2bx(str)
     char *str;
{	
  if (strcmp(str,"T\n") == 0) 
    return TRUE;
  if (strcmp(str,"F\n") == 0) 
    return FALSE;
  else 
    return UN_KNOWN;
} /* a2bx */

/******************************************************************/
static boole
a2be(str)
     char *str;
{	
  if (strcmp(str,"T\n") == 0) 
    return TRUE;
  else 
    return FALSE;
} /* a2be */

/******************************************************************/
static void
readstr(str,strl)
     register string str;
     posint strl;
{ 
  posint pos = 0;
  register posint j;
	
  while (strl) 
    {
      frdin();
      for(j=0; line[j] != '\n'; ) 
	{
	  str[pos++] = line[j++];
	  strl--;
	}	
    }
  frdin();
} /* readstr */

/******************************************************************/
static boole
rdinsf(csf,mno)
     register starfexp csf;
     posint mno;
{
  register posint i,j;
  
  csf->ulength = newar(mno);
  csf->vlength = newar(mno);
  csf->w0length = newar(mno);
  csf->w1length = newar(mno);
  csf->u = newarray1(mno);
  csf->v = newarray1(mno);
  csf->w0 = newarray1(mno);
  csf->w1 = newarray1(mno);
  csf->computed = newbarray(mno);

  frdin(); 
  if (strcmp(line,text[SFENO]) != 0) 
    {
      freesf(csf,FALSE,mno); 
      return FALSE; 
    }
	
  for(i=0; i < mno;) 
    { 
      frdin(); 
      csf->ulength[i++] = a2pi(line); 
    }
	
  frdin(); 
  if (strcmp(line,text[SFENO+1]) != 0) 
    {
      freesf(csf,FALSE,mno); 
      return FALSE; 
    }
	
  for(i=0; i < mno;) 
    { 
      frdin(); 
      csf->vlength[i++] = a2pi(line); 
    }
	
  frdin(); 
  if (strcmp(line,text[SFENO+2]) != 0) 
    {
      freesf(csf,FALSE,mno);
      return FALSE; 
    }
	
  for(i=0; i < mno;) 
    { 
      frdin(); 
      csf->w0length[i++] = a2pi(line); 
    }
	
  frdin(); 
  if (strcmp(line,text[SFENO+3]) != 0) 
    {
      freesf(csf,FALSE,mno); 
      return FALSE; 
    }
	
  for(i=0; i < mno;) 
    {
      frdin(); 
      csf->w1length[i++] = a2pi(line); 
    }

  for(i=0; i < mno; i++) 
    {
      csf->u[i] = newar(2*csf->ulength[i]);
      csf->v[i] = newar(2*csf->vlength[i]);
      csf->w0[i] = newar(3*csf->w0length[i]);
      csf->w1[i] = newar(csf->w1length[i]);
    }

  frdin(); 
  if (strcmp(line,text[SFENO+4]) != 0) 
    {
      freesf(csf,TRUE,mno); 
      return FALSE; 
    }
	
  for(i=0; i < mno; i++) 
    for(j=0; j < 2*csf->ulength[i];) 
      {
	frdin(); 
	csf->u[i][j++] = a2pi(line); 
      }
  
  frdin(); if (strcmp(line,text[SFENO+5]) != 0) 
    {
      freesf(csf,TRUE,mno); 
      return FALSE; 
    }
	
  for(i=0; i < mno; i++) 
    for(j=0; j < 2*csf->vlength[i];) 
      {
	frdin(); 
	csf->v[i][j++] = a2pi(line); 
      }
	
  frdin(); 
  if (strcmp(line,text[SFENO+6]) != 0) 
    {
      freesf(csf,TRUE,mno); 
      return FALSE; 
    }
	
  for(i=0; i < mno; i++) 
    for(j=0; j < 3*csf->w0length[i];) 
      {
	frdin(); 
	csf->w0[i][j++] = a2pi(line); 
      }
	
  frdin(); 
  if (strcmp(line,text[SFENO+7]) != 0) 
    {
      freesf(csf,TRUE,mno); 
      return FALSE; 
    }
	
  for(i=0; i < mno; i++) 
    for(j=0; j < csf->w1length[i];) 
      {
	frdin(); 
	csf->w1[i][j++] = a2pi(line); 
      }
  
  frdin(); 
  if (strcmp(line,text[SFENO+8]) != 0) 
    {
      freesf(csf,TRUE,mno); 
      return FALSE; 
    }
	
  for(i=0; i < mno;) 
    {
      frdin(); 
      csf->computed[i++] = a2be(line);
    }
	
  frdin(); 
  if (strcmp(line,text[SFENO+9]) != 0) 
    {
      freesf(csf,TRUE,mno); 
      return FALSE; 
    }
  
  return TRUE;
} /* rdinsf */

/******************************************************************/
static boole
rdinrex(crex)
     register regex crex;
{ 
  int i;
	
  frdin(); 
  if (strcmp(line,text[REGNO]))
    return FALSE;
	
  frdin(); 
  crex->useda = (int)a2pi(line) - 1;
	
  frdin(); 
  crex->sno = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[REGNO+1]))
    return FALSE;
	
  frdin(); 
  crex->rexl = a2pi(line);
	
  frdin(); 
  crex->erexl = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[REGNO+2]))
    return FALSE;
  
  frdin();  
  frdin(); 
  crex->grex = a2be(line);
	
  frdin(); 
  if (strcmp(line,text[REGNO+3]))
    return FALSE;
  
  for(i=0; i <= crex->useda; i++) 
    {
      frdin(); 
      crex->abbl[i] = a2pi(line);
    }
  
  frdin(); 
  if (strcmp(line,text[REGNO+4]))
    return FALSE;
	
  for(i=0; i<= crex->useda; i++) 
    crex->abbr[i] = newrexstr(crex->abbl[i]);
	
  crex->rex = newrexstr(crex->rexl);
  crex->exprex = newrexstr(crex->erexl);

	
  for(i=0; i <= crex->useda; i++) 
    {
      readstr(crex->abbr[i],crex->abbl[i]);
      frdin();
    }
	
  frdin(); 
  if (strcmp(line,text[REGNO+5])) {
    freerex(crex); return FALSE; }
	
  readstr(crex->rex,crex->rexl);
  
  frdin();
  readstr(crex->exprex,crex->erexl);
	
  return TRUE;
} /* rdinrex */

/******************************************************************/

static boole
rdindfa(cdfa)
     register dfa cdfa;
{ 
  register posint j,i;
  
  frdin(); 
  if (strcmp(line,text[DFANO]) != 0) 
    return FALSE;

  frdin(); 
  cdfa->qno = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[DFANO+2]) != 0) 
    return FALSE;
	
  frdin(); 
  cdfa->init = a2pi(line);  
	
  frdin(); 
  if (strcmp(line,text[DFANO+3]) != 0) 
    return FALSE;
	
  frdin(); 
  cdfa->sno = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[DFANO+4]) != 0) 
    return FALSE;
	
  frdin(); 
  cdfa->minimal = a2be(line);
	
  frdin(); 
  if (strcmp(line,text[DFANO+5]) != 0) 
    return FALSE;
  cdfa->final = newfinal(cdfa->qno);
  cdfa->delta = newddelta(cdfa->sno,cdfa->qno);
	
  for(i=0; i<=cdfa->qno; ) 
    {
      frdin(); 
      cdfa->final[i++] = a2bx(line);
    }
	
  frdin(); 
  if(strcmp(line,text[DFANO+6]) != 0) 
    {
      freedfa(cdfa);
      return FALSE;
    }
	
  for(i=1; i<=cdfa->sno; i++)
    for(j=0; j<=cdfa->qno; ) 
      {
	frdin(); 
	cdfa->delta[i][j++] = a2pi(line); 
      }
  
  frdin(); 
  if(strcmp(line,text[DFANO+7]) != 0) 
    {
      freedfa(cdfa);
      return FALSE;
    }
	
  return TRUE;
} /* rdindfa */

/******************************************************************/
static boole
rdinnfa(cnfa)
     nfa cnfa;
{ 
  register posint k,j,i;
	
  frdin(); 
  if (strcmp(line,text[NFANO]) != 0) 
    return FALSE;
	
  frdin(); 
  cnfa->qno = a2pi(line);
  /* when reading older automata with several initial states, the qno might
     be 1 higher than expected. The additional state will be superflous */
  /* do not worry, it will not cause any troubles */

  if (version<1)
    {
      frdin(); 
      if (strcmp(line,text[NFANO+2]) != 0) 
	return FALSE;
      
      frdin(); /* read a dummy */
    }
	
  frdin(); 
  if (strcmp(line,text[NFANO+3]) != 0) 
    return FALSE;
	
  frdin(); 
  cnfa->sno = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[NFANO+4]) != 0)
    return FALSE;
  
  frdin(); 
  cnfa->is_eps = a2be(line);
  
  if (version<1)
    {
      frdin(); /* reada dummy */
    }
  
  frdin(); 
  cnfa->minimal = a2be(line);
	
  frdin(); 
  if (strcmp(line,text[NFANO+5]) != 0) 
    return FALSE;
  cnfa->infin = newfinal(cnfa->qno);
  cnfa->delta = newndelta(cnfa->sno,cnfa->qno);
	
  for(i=0; i<=cnfa->qno; ) 
    {
      frdin(); 
      cnfa->infin[i++] = a2i(line);
    }
  
  frdin(); 
  if(strcmp(line,text[NFANO+6]) != 0) 
    {
      freenfa(cnfa);
      return FALSE;
    }
  
  for(k=0; k<=lastdelta(cnfa->qno); k++)
    for(i=(cnfa->is_eps)?0:1; i<=cnfa->sno; i++)
      for(j=0; j<=cnfa->qno; j++) 
	{
	  frdin(); 
	  cnfa->delta[i][j][k] = (char)a2i(line); 
	}
	
  frdin(); 
  if(strcmp(line,text[NFANO+7]) != 0) 
    {
      freenfa(cnfa);
      return FALSE;
    }
	
  return TRUE;
} /* rdinnfa */

/******************************************************************/
static boole
rdindcl(c)
     dstruct *c;
{ 
  register posint i,j;
  darray dc;
  
  (*c) = newdstruct();

  frdin(); 
  if (strcmp(line,text[DCLNO]) != 0) 
    {
      freedcl((*c),0); 
      return FALSE; 
    }
	
  frdin(); 
  (*c)->dno = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[DCLNO+1]) != 0) 
    {
      freedcl((*c),0); 
      return FALSE; 
    }
	
  frdin(); 
  (*c)->rno = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[DCLNO+2]) != 0) 
    {
      freedcl((*c),0); 
      return FALSE; 
    }
  
  frdin(); 
  (*c)->lno = a2pi(line);
  (*c)->dclassarray = newdarray((*c)->dno);
  dc = (*c)->dclassarray;
	
  for(i=0; i < (*c)->dno; i++) 
    dc[i] = newdclass();
  
  if(version<1)
    {
      frdin(); 
      if (strcmp(line,text[DCLNO+3]) != 0) 
	{
	  freedcl((*c),0); return FALSE; 
	}
      frdin(); /*dummy */
    }

  frdin(); 
  if (strcmp(line,text[DCLNO+4]) != 0) 
    {
      freedcl((*c),0); 
      return FALSE; 
    }
	
  for(i=0; i < (*c)->dno; i++) 
    {
      frdin();
      if (strcmp(line,text[DCLNO+5]) != 0) 
	{
	  freedcl((*c),i); 
	  return FALSE; 
	}
		
      frdin(); 
      dc[i]->org = a2pi(line);
	
      frdin(); 
      dc[i]->rno = a2pi(line);
	
      frdin(); 
      dc[i]->lno = a2pi(line);
	
      frdin(); 
      dc[i]->hsize = a2pi(line);
	
      frdin(); 
      dc[i]->rang = a2pi(line);
	
      frdin(); 
      dc[i]->maxlen = a2pi(line);
      
      frdin(); 
      dc[i]->regular = a2be(line);
      dc[i]->lrep = newar(dc[i]->lno);
      dc[i]->hclass = newar(dc[i]->hsize);
      dc[i]->rrep = newar(dc[i]->rno);

      frdin(); 
      if (strcmp(line,text[DCLNO+6]) != 0) 
	{
	  freedcl((*c),i+1); 
	  return FALSE; 
	}
	
      for(j=0; j < dc[i]->lno; ) 
	{ 
	  frdin(); 
	  dc[i]->lrep[j++] = a2pi(line); 
	}

      frdin(); 
      if (strcmp(line,text[DCLNO+7]) != 0) 
	{
	  freedcl((*c),i+1); 
	  return FALSE; 
	}
	
      for(j=0; j < dc[i]->rno; ) 
	{ 
	  frdin(); 
	  dc[i]->rrep[j++] = a2pi(line); 
	}
	
      frdin(); 
      if (strcmp(line,text[DCLNO+8]) != 0) 
	{
	  freedcl((*c),i+1); 
	  return FALSE; 
	}
	
      for(j=0; j < dc[i]->hsize; ) 
	{ 
	  frdin(); 
	  dc[i]->hclass[j++] = a2pi(line); 
	}
    }
	
  return TRUE;
} /* rdindcl */

/******************************************************************/
static boole
rdinmon(cmon)
     register monoid cmon;
{ 
  register posint i,j;
  posint rno;
	
  frdin(); 
  if (strcmp(line,text[MONNO]) != 0) 
    return FALSE;
	
  frdin(); 
  cmon->qno = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[MONNO+2]) != 0) 
    return FALSE;
	
  frdin(); 
  cmon->sno = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[MONNO+3]) != 0) 
    return FALSE;
	
  frdin(); 
  cmon->mno = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[MONNO+4]) != 0) 
    return FALSE;
	
  frdin(); 
  cmon->gno = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[MONNO+8]) != 0) 
    return FALSE;
	
  frdin(); 
  cmon->zero = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[MONNO+14]) != 0) 
    return FALSE;
	
  frdin(); 
  rno = a2pi(line); /* if 0 then defining relations have
		       not been computed */

  /* oma */
  if (rno != 0) 
    {
      cmon->relationcomputed = TRUE;
      cmon->rs = newrstruct();
      cmon->rs->rno = rno;
      cmon->rs->rside = newar(rno);
      cmon->rs->lside = newar(rno);
      for(i=0; i < rno; i++ )
	{
	  frdin(); 
	  cmon->rs->rside[i] = a2pi(line);
	  frdin(); 
	  cmon->rs->lside[i] = a2pi(line); 
	}
    }
  else
    {
      cmon->relationcomputed = FALSE;
    }
  
  cmon->generator = newar(cmon->gno + 1);
  cmon->let2gen = newar(cmon->sno + 1);
  cmon->gensucc = newarray1(cmon->mno);
  cmon->no2trans = newarray1(cmon->mno);
  
  for(i=0;i<cmon->mno;) 
    {
      cmon->gensucc[i]=newar(cmon->gno);
      cmon->no2trans[i++]=newar(cmon->qno);
    }
  
  frdin(); 
  if (strcmp(line,text[MONNO+5]) != 0)
    return FALSE;
	
  for(i=0; i <= cmon->gno; ) 
    { 
      frdin(); 
      cmon->generator[i++] = a2pi(line); 
    }
	
  frdin(); 
  if (strcmp(line,text[MONNO+6]) != 0)  
    {
      freemon(cmon); 
      return FALSE; 
    }
  
  for(i=0; i <= cmon->sno; ) 
    { 
      frdin(); 
      cmon->let2gen[i++] = a2pi(line); 
    }
	
  frdin(); 
  if (strcmp(line,text[MONNO+7]) != 0) 
    {
      freemon(cmon); 
      return FALSE; 
    }
	
  for(i=0; i < cmon->mno; i++) 
    {
      for(j=1; j <= cmon->gno; ) 
	{
	  frdin(); 
	  cmon->gensucc[i][j++] = a2pi(line); 
	} 
      frdin();
    }
  
  frdin(); 
  if (strcmp(line,text[MONNO+11]) != 0) 
    {
      freemon(cmon); return FALSE; 
    }
	
  frdin(); 
  cmon->dclassiscomputed = a2be(line);
  
  frdin(); 
  cmon->mequals = a2be(line);
	
  frdin(); 
  if (strcmp(line,text[MONNO+12]) != 0) 
    {
      freemon(cmon); 
      return FALSE; 
    }
	
  if (cmon->dclassiscomputed) 
    {
      frdin(); 
      if(strcmp(line,text[MONNO+13]) != 0) 
	{
	  freemon(cmon); 
	  return FALSE; 
	}
	
      if(version<1)
	{
	  for(i=0; i < cmon->mno;i++ )
	    frdin(); /* dummy */
	}
      if (!rdindcl(&(cmon->ds))) 
	cmon->dclassiscomputed = FALSE;
    }
  
  return TRUE;
} /* rdinmon */

/******************************************************************/
boolx
rdinlan(fname,idx)
     char *fname;
     int idx;
{ 
  register language lanin;
  int i;
  boole resave;
	
  lanin = langs[idx];
  for(i=0; i < NLEN; i++) 
    lanin->name[i] = fname[i];
  
  (void)strcpy(fname,workdir);
  (void)strcat(fname,lanin->name);
  (void)strcat(fname,".amr");
  
  if ((amrp=fopen(fname,"r")) == NULL) 
    {
#ifdef DEBUG
      perror("rdinlan 1");
#endif
      return UN_KNOWN;
    }

  frdin();
  if(strncmp(line,text[GLBNO],LEN_OF_HEADER) != 0) 
    return FALSE;
  
  version=CUR_VERSION+1;
  for(i=0;i<=CUR_VERSION;i++)
    if(strcmp(&(line[LEN_OF_HEADER]),versiontext[i]) == 0) 
      {
	version=i;
	break;
      }
  if (version==CUR_VERSION+1) return FALSE;
  
  
  frdin(); 
  if (strcmp(line,text[GLBNO+1]) != 0) 
    return FALSE;
	
  frdin();
  frdin(); 
  (void)strcpy(lanin->ref,line);
  lanin->ref[strlen(line)-1] = '\0'; /* delete '\n' */
  lanin->saved = TRUE;
	
  frdin(); 
  if (strcmp(line,text[GLBNO+2]) != 0) 
    return FALSE;
	
  frdin(); 
  lanin->sizeal = a2pi(line);
	
  frdin(); 
  if (strcmp(line,text[GLBNO+3]) != 0) 
    return FALSE;
	
  frdin(); 
  lanin->inputis = a2i(line);
	
  switch (lanin->inputis) 
    {
    case REXINP:
    case DFAINP:
    case NFAINP: 
      break;
    case OREXINP: 
      lanin->orex = newrex();
      if (!rdinrex(lanin->orex)) 
	{
	  dispose(lanin->orex);
	  lanin->inputis = REXINP;
	  return FALSE;
	} 
      break;
    case ODFAINP: 
      lanin->odfa = newdfa();
      if (!rdindfa(lanin->odfa)) 
	{
	  dispose(lanin->odfa);
	  lanin->inputis = DFAINP;
	  return FALSE;
	} 
      break;
    case ONFAINP: 
      lanin->onfa = newnfa();
      if (!rdinnfa(lanin->onfa)) 
	{
	  dispose(lanin->onfa);
	  lanin->inputis = NFAINP;
	  return FALSE;
	} 
      break;
    case OENFAINP:
      lanin->oenfa = newnfa();
      if (!rdinnfa(lanin->oenfa)) 
	{
	  dispose(lanin->oenfa);
	  lanin->inputis = OENFAINP;
	  return FALSE;
	} 
      break;
    default: 
      return FALSE;
    }
  
  frdin(); 
  if (strcmp(line,text[GLBNO+4]) != 0) 
    return FALSE;
	
  frdin(); 
  if (strcmp(line,text[GLBNO+5]) != 0) 
    return FALSE;
	
  frdin(); 
  lanin->brex = a2be(line);	
  if (lanin->brex) 
    {
      lanin->lrex = newrex();
      if (!rdinrex(lanin->lrex)) 
	{
	  dispose(lanin->lrex);
	  lanin->brex = FALSE;
	  return FALSE;
	}	
    }
	
  frdin(); 
  if (strcmp(line,text[GLBNO+6]) != 0) 
    return FALSE;
  
  frdin(); 
  lanin->bdfa = a2be(line);
  if (lanin->bdfa) 
    {
      lanin->ldfa = newdfa();
      if (!rdindfa(lanin->ldfa)) 
	{
	  dispose(lanin->ldfa);
	  lanin->bdfa = FALSE;
	  return FALSE;
	}	
    }
	
  frdin(); 
  if (strcmp(line,text[GLBNO+7]) != 0) 
    return FALSE;
	
  frdin(); 
  lanin->bnfa = a2be(line);
  if (lanin->bnfa) 
    {
      lanin->lnfa = newnfa();
      if (!rdinnfa(lanin->lnfa)) 
	{
	  dispose(lanin->lnfa);
	  lanin->bnfa = FALSE;
	  return FALSE;
	}	
    }
  
  frdin(); 
  if (strcmp(line,text[GLBNO+8]) != 0) 
    return FALSE;
  
  frdin(); 
  lanin->bmon = a2be(line);
  if (lanin->bmon) 
    {
      lanin->lmon = newmon();
      if (!rdinmon(lanin->lmon)) 
	{
	  dispose(lanin->lmon);
	  lanin->bmon = FALSE;
	  return FALSE;
	}
      comprestofmon(lanin->lmon,lanin->ldfa);
    }
	
  frdin(); 
  if(strcmp(line,text[GLBNO+9]) != 0) 
    return FALSE;
	
  frdin(); 
  lanin->stariscomp = a2be(line);
  if ((lanin->bmon) && (lanin->stariscomp)) 
    {
      lanin->sexp = newsfexp();
      if (!rdinsf(lanin->sexp,lanin->lmon->mno)) 
	{
	  dispose(lanin->sexp);
	  lanin->stariscomp = FALSE;
	  return FALSE;
	}	
    }
  
  frdin(); if (strcmp(line,text[GLBNO+10]) != 0) 
    return FALSE;
  
  frdin(); 
  lanin->empty = a2bx(line);
  frdin(); 
  lanin->full = a2bx(line);
  frdin(); 
  lanin->folu = a2bx(line);
  frdin(); 
  lanin->starfree = a2bx(line);
  frdin(); 
  lanin->localtest = a2bx(line);
  frdin(); 
  lanin->definite = a2bx(line);
  frdin(); 
  lanin->revdefinite = a2bx(line);
  frdin(); 
  lanin->gendefinite = a2bx(line);
  frdin(); 
  lanin->dotdepth1 = a2bx(line);
  frdin(); 
  lanin->piecetest = a2bx(line);
  frdin(); 
  lanin->nilpotent = a2bx(line);

  /* --- Bordeaux : 1995 : start --- */  
  if ( version == CUR_VERSION ) 
    {                           
      frdin();                  
      if (strcmp(line, text[GLBNO+11]) != 0)  
	return FALSE;                         
      frdin();                                
      lanin->code = a2bx(line);               
      frdin();                                
      lanin->stack_code = a2bx(line);         

      frdin();                                
      if ( strcmp(line, text[GLBNO+12]) != 0 )
	return FALSE;                         
      frdin();                                
      lanin->prefix_code = a2bx(line);        
      frdin();                                
      lanin->suffix_code = a2bx(line);        
      frdin();                                
      lanin->bifix_code = a2bx(line);         
      frdin();                                
      lanin->p_infix_code = a2bx(line);       
      frdin();                                
      lanin->s_infix_code = a2bx(line);       
      frdin();                                
      lanin->infix_code = a2bx(line);         

      frdin();                                
      if (strcmp(line, text[GLBNO+13]) != 0)      
	return FALSE;                             
      frdin();
      lanin->right_semaphore_code = a2bx(line);   
      frdin();                                    
      lanin->left_semaphore_code = a2bx(line);    

      frdin();
      if (strcmp(line, text[GLBNO+14]) != 0)      
	return FALSE;                             
      frdin();                                    
      lanin->outfix_code = a2bx(line);            
      frdin();                                    
      lanin->hypercode = a2bx(line);              
      frdin();                                    
      lanin->uniform_code = a2bx(line);           
      frdin();                                    
      lanin->full_uniform_code = a2bx(line);      

      frdin();                                    
      if ( strcmp(line, text[GLBNO+15]) != 0 )    
	return FALSE;                             
      frdin();                                    
      if( lanin->word_not_code == NULL )
	lanin->word_not_code = (char *) malloc( strlen(line) * sizeof(char));
      else
	lanin->word_not_code = (char *) realloc(lanin->word_not_code,
						strlen(line) * sizeof(char));  
      if( lanin->word_not_code == NULL )
	free_resources(1);
      strcpy(lanin->word_not_code, line);        
      
      frdin();
      while( strcmp(line, text[GLBNO+16]) != 0 )   
	{
	  lanin->word_not_code = (char *) realloc(lanin->word_not_code, strlen(line) +
						  strlen(lanin->word_not_code));
	  if( lanin->word_not_code == NULL )
	    free_resources(1);
	  strcat(lanin->word_not_code, line);
	  frdin();
	}       
      lanin->word_not_code[strlen(lanin->word_not_code)-1] = '\0'; 

      if ( strcmp(line, text[GLBNO+16]) != 0 )      
	return FALSE;                               
    }
      
  frdin(); 
  lanin->localdegree = a2pi(line);
  
  if (ferror(amrp)) 
    {
      (void)fclose(amrp);
      return FALSE;
    }
	
  (void)fclose(amrp);
  
  if(version != CUR_VERSION)
    {
      lanin->code = UN_KNOWN;                        
      lanin->stack_code = UN_KNOWN;                  
      lanin->prefix_code = UN_KNOWN;                 
      lanin->suffix_code = UN_KNOWN;                 
      lanin->bifix_code = UN_KNOWN;                  
      lanin->p_infix_code = UN_KNOWN;                
      lanin->s_infix_code = UN_KNOWN;                
      lanin->infix_code = UN_KNOWN;                  
      lanin->outfix_code = UN_KNOWN;                 
      lanin->hypercode = UN_KNOWN;                   
      lanin->right_semaphore_code = UN_KNOWN;        
      lanin->left_semaphore_code = UN_KNOWN;         
      lanin->uniform_code = UN_KNOWN;                
      lanin->full_uniform_code = UN_KNOWN;      

      if( lanin->word_not_code == NULL )
	lanin->word_not_code = (char *) malloc((strlen(WORD_NOT_CODE_DEFAULT) + 1) * sizeof(char));
      else
	lanin->word_not_code = (char *) realloc(lanin->word_not_code,
						(strlen(WORD_NOT_CODE_DEFAULT) + 1) * sizeof(char));
      
      if( lanin->word_not_code == NULL )
	free_resources(1);

      strcpy (lanin->word_not_code, WORD_NOT_CODE_DEFAULT);

      help(FALSE,"Older Save-File version, converting to new... ");
      switch(writelan(maxidx))
	{
	case TRUE:
	  help(FALSE,"Older Save-File version, converting to new...o.k");
	  return TRUE;
	case FALSE:
	  help(FALSE,"SAVE LANGUAGE: error! cannot open file.");
	  return FALSE;
	case UN_KNOWN:
	  help(FALSE,"SAVE LANGUAGE: error in writing");
	  return FALSE;
	}					
    }
  /* --- Bordeaux : 1995 :end --- */

  return TRUE;  /* never reached */
} /* rdinlan */










