/* screen.c 3.0 (KIEL) 11.94 */

#include "ext.h"

/* functions included:
 *
 *		void  mess()
 *		void  help()
 *		void  prtstr()
 *		int   needlines()
 *		void  initcurses()
 *		void  endcurses()
 */

/******************************************************************/
/******************************************************************/
void
mess(txt)
char *txt;
{	move(HELPROW,HELPCOL);  /* goto helpline */
	clrtoeol();    	        /* clear line */
	addstr(txt);    	/* write message */
	refresh();		/* show changes */
} /* mess */

/******************************************************************/
void
help(pause,txt)
boole pause;	/* TRUE if a getch() should be appended */
char *txt; 	/* Text to be printed at the helpline */
{	move(HELPROW,HELPCOL);  /* goto helpline */
	clrtoeol();    	        /* clear line */
	addstr(txt);    	/* write help message */
	inputpos;		/* normal cursor position */
	refresh();		/* show changes */
	if (pause) { (void)getch();	/* wait for keystroke */
		move(HELPROW,HELPCOL); clrtoeol();
		addstr(txt); addstr(" O.k.");
		inputpos; refresh();
	}
} /* help */

/******************************************************************/
static string
prt_str(r,c,str,len,dopg)
int r,c,len;
string str;
boole dopg;
{ char ch;
	ch = str[len];
	str[len] = '\0';
	if (dopg) pgmvaddstr(r,c,str);
	else mvaddstr(r,c,str);
	str[len] = ch;
	return (str + len);
} /* prt_str */

/******************************************************************/
/* VARARGS9 */
void
prtstr(r,c,ce,str,xro,xco,mr,dopg,enh,newr,newc)
int r,c,ce,xro,xco,mr;
string str;
boole dopg,enh;
int *newr,*newc;
/* print string str at screenposition (r,c) and wrap around
 * at position (r,ce) and go on at position (r+xro,xco),
 * wrap around at (r+xro,ce), go on at (r+xro+xro,xco) etc
 * but use no more than mr lines
 *   ............. line r
 *                  xro-1 empty lines 
 *     ........... line r+xro
 *   c xco        ce is first empty
 * xro may be negativ
 * r,c,ce,mr,xco must be positiv
 * max(c,xco)<ce 
 *
 * if(enh) return in newr,newc the next free position
 */
{ register int diff;
  string hlp;
  register posint strlength;
  int count = 1;
	
	diff = ce - c;
	strlength = (posint)strlen(str);
	hlp = str;

	if (strlength <= diff) {
	   if (dopg) pgmvaddstr(r,c,hlp);
	   else      mvaddstr(r,c,hlp);
	} else { 
	       hlp = prt_str(r,c,hlp,diff,dopg);
	       strlength = (strlength > diff)? strlength-diff : 0;
	       diff = ce-xco; c = xco;
	       while ((strlength > diff) && (count < mr)) {
	       	    strlength = (strlength > diff)? strlength-diff : 0;
	       	    r += xro;
		    hlp = prt_str(r,c,hlp,diff,dopg);
		    count++;
	       }
	       if ((strlength) && (count == mr)) {
		 if (dopg) pgmvaddstr(r,ce-3,"...");
		 else      mvaddstr(r,ce-3,"...");
	       } else if (strlength <= diff) {
		 if (dopg) pgmvaddstr(r+xro,c,hlp);
		 else      mvaddstr(r+xro,c,hlp);
		 count++;
	}      }
	if(enh)
	   {*newr=r;*newc=c+strlength;}
} /* prtstr */

/******************************************************************/
int
needlines(c,ce,str,length,lors,xco)
char *str;
int c,ce,xco;
posint length;
boole lors;
/* counts the number of lines needed to print 
 *   str (if lors==FALSE)
 *   a string with length length (if lors==FALSE) 
 *   with prtstr
 * RETURN: number of lines
 */
{ int diff;
  posint strlength;
  int count = 1;
	diff = ce - c;
	strlength =(lors)? length : (posint)strlen(str);
	if(strlength<=diff)return(1);
	strlength -= diff; diff = ce-xco;
        count+=(strlength/diff);
	if (strlength%diff) count++;
	return (count);
} /* needlines */

/******************************************************************/
void
initcurses()
/* init curses */
{	initscr();    /* initialize curses */

	/* LINT is confused of some vars in the following macros */
#ifndef lint
	noecho();     /* no echo on screen */
	nonl();       /* no CR to NL */
	cbreak();     /* Zeichenweise Eingabe */
#endif
	if ((COLS < 80) || (LINES < 24)) {
		endcurses(FALSE);
		(void)printf("\n\n AMORE needs a terminal with \n at least 80 columns and 24 rows\n\n");
		exit(1);
	}
} /* initcurses */

/******************************************************************/
void
endcurses(ex)
boole ex;
/* ends curses and if ex == TRUE exits */
{	clear();
	nocbreak();	/* Zeilenweise Eingabe */
	endwin();
        echo();
	if (ex) (void)exit(0);
} /* endcurses */
