/* win_com.c 3.0 (KIEL) 11.94 */

#include "ext.h"

/* functions included:
 * 
 *		void  createlan()
 *		void  deletelan()
 *		void  modify()
 *		void  print()
 *		void  chgelan()
 *	static boolx displaydfa()
 *	static boolx displaynfa()
 *		void  display()
 *		void  savelan()
 *		void  loadlan()
 */

/******************************************************************/
void
createlan()
{ boole res=FALSE;
	if (maxidx == NLANG) help(FALSE,"CREATE: Please delete a language.");
	else {
	  inpmenu(LANGMENU,TRUE); /* show only possible choices */
	  help(FALSE,"Enter letter and number for the way to define the language (q quit)");
	  switch(getch()){
	  case 'E': /* read an expression */
	  case 'e': res = readexp(FALSE,getch()); break;
	  case 'A': /* read an automata */
	  case 'a': res = readaut(FALSE,getch()); break;
	  case 'q': /* cancel */
		    help(FALSE,"QUIT: create new language"); break;
	  default : /* wrong choice */
		    help(FALSE,"Wrong choice: aborted");
	  } /* end switch */
	  if (res)  curidx = maxidx++;
	  drawmenu(menu);
	}
} /* createlan */

/******************************************************************/
void
deletelan()
/* delete a language from langs */
{ char ch;		/* input */
  char idx,oldidx;	/* idx language to delete, oldidx current curidx */
  boole dodel = FALSE;  /* TRUE iff delete */
  boole change = FALSE; /* TRUE iff language mark changed */
	oldidx = (char)curidx;

	if (!maxidx) { 
		help(FALSE,"DELETE: Sorry, no language known, quit.");
		return;
	}
	/* get number of language to delete */
	do {	help(FALSE,"DELETE: enter number of language to delete (0=quit): ");
		ch = getch();
	} while ((ch < '0') || (ch > '9'));

	if (ch == '0') help(FALSE,"DELETE: quit");
	else {	idx = ch -'1';
		if (idx >= maxidx) help(FALSE,"DELETE: unknown language");
		else {  /* language known, but test if delete should be confirmed */
		      if (!langs[idx]->saved) {  /* language is not saved */
		    	chgelan(idx); change = TRUE;
		    	help(FALSE,"DELETE: marked language not saved. Delete it? (y/n):");
		    	ch = getch();
		    	if (!((ch == 'y') || (ch == 'Y')))
			       help(FALSE,"DELETE: nothing changed");
			else dodel = TRUE;   /* delete language */
		      } else dodel = TRUE;   /* language saved, delete it */
	}	}
	if (dodel) {		/* delete language langs[idx] */
		if (--maxidx == idx) (void)newlang(idx);
		else movelang((int)idx,maxidx);
		change = TRUE;
		if (idx == oldidx) oldidx = '\0';
		if (idx < oldidx)  oldidx--;
	}
	if (change) chgelan(oldidx);
	updatewin(LWIN);
} /* deletelan */

/******************************************************************/
void
modify()
{ boole res=TRUE;
  char ch;
	if (!maxidx) help(FALSE,"MODIFY: Sorry, no language known, quit.");
	else if (maxidx == NLANG) help(FALSE,"MODIFY: Please delete a language.");
	else {
		help(FALSE,"MODIFY: enter number of language to modify (0: quit)");
		ch = getch();
		if (ch == '0') res = TRUE;
		else if ((ch < '1') || (ch > '9') || (ch - '0' > maxidx)) {
			help(FALSE,"MODIFY: wrong number; quit");
			res = TRUE;
		} else {
			curidx = (int)(ch -'1');
			curlan = langs[curidx];
			mlang =  curlan;
			res = FALSE;
		}
		if (!res) {
	  		inpmenu(LANGMENU,UN_KNOWN); /* show only possible choices */
			updatewin(AWIN);
			updatewin(AWIN);
	  		help(FALSE,"Enter letter and number for the way to modify the language (q quit)");
	  		switch(getch()){
	  		case 'E': /* read an expression */
	  		case 'e': res = readexp(TRUE,getch()); break;
	  		case 'A': /* read an automata */
	  		case 'a': res = readaut(TRUE,getch()); break;
	  		case 'q': /* cancel */
		    		help(FALSE,"MODIFY: quit"); break;
	  		default : /* wrong choice */
		    		help(FALSE,"MODIFY: wrong choice; quit");
	  		} /* end switch */
	  		if (res)  curidx = maxidx++;
	  		drawmenu(menu);
	}	}
} /* modify */
/******************************************************************/
void
print()
{
	if (!maxidx) help(FALSE,"PRINT: Sorry, no language known, quit.");
	else {
	  help(FALSE,"PRINT: enter letter and number (q: quit)");
	  switch(getch()){
	  case 'E':
	  case 'e': switch(getch()){
		    case '1': printrex(TRUE); break;
		    case '2': printrex(FALSE); break;
		    case '3': printsfx(); break;
	  	    default: help(FALSE,"PRINT: wrong choice; quit");
		    }
		    break;
	  case 'A':
	  case 'a': switch(getch()){
		    case '1': printdaut(FALSE); break;
		    case '2': printnaut(FALSE); break;
		    case '3': printnaut(TRUE); break;
		    case '4': printdaut(TRUE); break;
		    case '5': printnaut(UN_KNOWN); break;
	  	    default: help(FALSE,"PRINT: wrong choice; quit");
		    }
		    break;
	  case 'M':
	  case 'm': switch(getch()) {
		    case '1': printmon(); break;
		    case '2': printdclass(); break;
		    case '3': printmult();break;
	  	    default: help(FALSE,"PRINT: wrong choice; quit");
		    }
		    break;
	  case 'q': /* quit */
		    break;
	  default: help(FALSE,"PRINT: wrong choice; quit");
	  }
	}
} /* print */

/******************************************************************/
void
chgelan(lanno)
char lanno;
/* changes curlan to langs[lanno] */
{	mvaddstr(IDXROW+curidx,MARKCOL,"  "); /* delete mark */
	curidx = (int)lanno;
	curlan = langs[curidx];               /* language changed */
	mvaddstr(IDXROW+curidx,MARKCOL,"->"); /* set new mark */
	if (menu == TESTMENU) {
		updatewin(OWIN);	      /* update lang. prop.*/
		updatewin(TWIN);
	}
	inputpos; refresh();
} /* chgelan */

/******************************************************************/
#ifdef DISPLAY
static boolx
displaydfa(cdfa,fname,des)
register dfa cdfa;
char *fname;
char * des;
{ register posint j,i,count;
  char name[PATHLEN+NLEN+5];
        (void)strcpy(name,displaydir);
        (void)strcat(name,fname);
	(void)strcat(name,des);
	if ((amrp=fopen(name,"w")) == NULL) {
#ifdef DEBUG
		perror("displaydfa 1");
#endif
		return UN_KNOWN;
	}

	fwrite(pi2a(cdfa->qno+1)); new_line;
	fwrite(pi2a(cdfa->sno)); new_line;
	fwrite("1\n"); new_line;
	fwrite("0\n");

	fwrite(pi2a(cdfa->init+1)); new_line;
	for(i=0; i<=cdfa->qno; ) {
		fwrite(pi2a((posint)cdfa->final[i++])); new_line;
	}

        count=(cdfa->qno+1)*cdfa->sno;
	fwrite(pi2a(count)); new_line;
	for(i=1; i<=cdfa->sno; i++)
		for(j=0; j<=cdfa->qno; j++ )
			{
			fwrite(pi2a(j+1)); new_line;
			fwrite(pi2a(cdfa->delta[i][j]+1)); new_line;
			fwrite(pi2a(i)); new_line;
			}

	(void)fclose(amrp);
	return TRUE;
} /* displaydfa */

/******************************************************************/
static boolx
displaynfa(cnfa,fname,des)
register nfa cnfa;
char *fname,*des;
{ posint k,j,i,init,count=0,countinit=0;
  char name[PATHLEN+NLEN+5];

  (void)strcpy(name,displaydir);
  (void)strcat(name,fname);
  (void)strcat(name,des);
  if ((amrp=fopen(name,"w")) == NULL) 
    {
#ifdef DEBUG
	perror("displaynfa 1");
#endif
	return UN_KNOWN;
    }
  /* check for number of initial states  and transitions
   * if more than one initial state:
   *    add new state and epsilon move from new state to initial states 
   */
  for(i=(cnfa->is_eps)?0:1; i<=cnfa->sno; i++)
    for(j=0; j<=cnfa->qno;j++)
      for(k=0; k<= cnfa->qno; k++)
        if(testcon(cnfa->delta,i,j,k))count++;
  for(i=0; i<=cnfa->qno; i++)
    if(isinit(cnfa->infin[i]))
      {countinit++;init=i;}
  /* number of states */
  if(countinit<=1) 
    {fwrite(pi2a(cnfa->qno+1)); new_line;} 
  else
    {fwrite(pi2a(cnfa->qno+2)); new_line;} 
  /* number of letters including epsilon */
  fwrite(pi2a(cnfa->sno)); new_line;
  /* epsilon-transitions */
  if((!cnfa->is_eps)&&(countinit<=1)) fwrite("0\n"); 
  else                                fwrite("1\n");
  new_line;
  if(countinit>1)                    fwrite("1\n"); 
  else                                fwrite("0\n");
  new_line;
  /* initial state */
  if(countinit<=1)
    {fwrite(pi2a(init+1)); new_line;}
  else
    {fwrite(pi2a(cnfa->qno+2)); new_line;} 
  /* final marks */
  for(k=0; k<=cnfa->qno; ) 
     {fwrite(pi2a((posint)isfinal(cnfa->infin[k++]))); new_line;}
  if(countinit>1)  /* new state is not final */
     {fwrite(pi2a(0)); new_line;}
  
  /* number of transitions */
  if(countinit<=1)
    {fwrite(pi2a(count)); new_line;}
  else
    {fwrite(pi2a(count+countinit)); new_line;} 
  for(i=(cnfa->is_eps)?0:1; i<=cnfa->sno; i++)
    for(j=0; j<=cnfa->qno; j++ )
      for(k=0; k<= cnfa->qno; k++)
        if(testcon(cnfa->delta,i,j,k))
          {fwrite(pi2a(j+1)); new_line;  /* from , to , letter */
	   fwrite(pi2a(k+1)); new_line;
	   if(i) fwrite(pi2a(i)); else fwrite(pi2a(cnfa->sno+1));
           new_line;
          }
  if(countinit>1)
     for(j=0; j<=cnfa->qno; j++)
       if(isinit(cnfa->infin[j]))
         {fwrite(pi2a(cnfa->qno+2)); new_line;
          fwrite(pi2a(j+1)); new_line;
          fwrite(pi2a(cnfa->sno+1)); new_line;
         }
  (void)fclose(amrp);
  return TRUE;
} /* displaynfa */

/******************************************************************/
void
display()
{ boolx res;
  char ch;
  char amdcmd[100+4+NLEN+3+1];
	if (!maxidx) {
		help(FALSE,"DISPLAY: Sorry, no language known, quit.");
		return;
	}

	help(FALSE,"DISPLAY: Please enter number of automata type");
	do ch = getch(); while ((ch > '4') && (ch < '1'));
	(void)strcpy(amdcmd,amddir);
	(void)strcat(amdcmd,"/amd ");
	(void)strcat(amdcmd,curlan->name);
	switch(ch){
	case '1': compdfa();
		  res = displaydfa(curlan->ldfa,curlan->name,".d");
		  (void)strcat(amdcmd,".d");
		  break;
	case '2': compnfa();
	          if(curlan->inputis == ONFAINP) 
		      res = displaynfa(curlan->onfa,curlan->name,".n");
                  else
		      res = displaynfa(curlan->lnfa,curlan->name,".n");
		  (void)strcat(amdcmd,".n");
		  break;
	case '3': if(curlan->inputis == OENFAINP) 
		      res = displaynfa(curlan->oenfa,curlan->name,".en");
                  else
                     {compnfa();
                      res = displaynfa(curlan->lnfa,curlan->name,".en");
                     }
		  (void)strcat(amdcmd,".en");
		  break;
	case '4': compmdfa();
		  res = displaydfa(curlan->ldfa,curlan->name,".md");
		  (void)strcat(amdcmd,".md");
		  break;
	case '5': compmnfa();
		  res = displaynfa(curlan->lnfa,curlan->name,".mn");
		  (void)strcat(amdcmd,".mn");
		  break;
	}
	switch(res){
	case FALSE: help(TRUE,"DISPLAY: Automata dimensions too large for display");
		    break;
	case UN_KNOWN: help(TRUE,"DISPLAY: write permission disabled");
		    break;
	case TRUE: {
		(void)system(amdcmd);
                drawmenu(menu);
		help(FALSE,"DISPLAY: done");
	}          }
} /* display */
#endif

#ifdef NODISPLAY
void display()
{
 help(FALSE,"DISPLAY available on SUN-computer only");
}
#endif

/******************************************************************/
void
savelan()
{ char ch;
  int idx;
	if (!maxidx) help(FALSE,"SAVE LANGUAGE: Sorry,no language known, quit.");
	else {
		help(FALSE,"SAVE LANGUAGE: please enter number of language");
		ch = getch();
		if ((ch < '1') || (ch > '9') || (ch -'0' > maxidx))
			help(FALSE,"SAVE LANGUAGE: wrong number; quit");
		else {
			idx = ch - '1';
			if (langs[idx]->saved) 
				help(FALSE,"SAVE LANGUAGE: language already saved.");
			else {
				help(FALSE,"SAVE LANGUAGE: saving...");
				switch (writelan(idx)) {
				case TRUE:
					langs[idx]->saved = TRUE;
					help(FALSE,"SAVE LANGUAGE: saving...ok");
					break;
				case FALSE:
					help(FALSE,"SAVE LANGUAGE: error! cannot open file.");
					break;
				case UN_KNOWN:
					help(FALSE,"SAVE LANGUAGE: error in writing");
	}	}	}	}
} /* savelan */

/******************************************************************/
void
loadlan(fromscreen,fname)
boole fromscreen;
char *fname;
/* loads a regular language from a file into memory
 * fromscreen TRUE iff interactive input
 * fname the language name
 */
{
char name[PATHLEN+NLEN+5];
	if (maxidx == NLANG) {
		help(FALSE,"LOAD LANGUAGE: please delete a language");
		return;
	}
	if (fromscreen) {
		if (!showdir("amr")) {
			help(FALSE,"LOAD LANGUAGE: cannot open directory");
			return;
		}
		help(FALSE,"LOAD LANGUAGE: enter name of language");
		rdnam(INPROW,INPCOL+INPOFF,fname,HELPROW,HELPCOL);
		drawmenu(menu);
	}
	(void)strcpy(name,fname);
	help(FALSE,"LOAD LANGUAGE: start reading...");
	switch(rdinlan(name,maxidx)) {
	case UN_KNOWN: /* file cannot be opened */
			help(FALSE,"LOAD LANGUAGE: cannot open file; quit.");
			break;
	case FALSE  : /* error reading information */
			help(FALSE,"LOAD LANGUAGE: error while reading information; quit.");
			langs[maxidx] = newlang(maxidx);
			break;
	case TRUE   : /* ok */
			help(FALSE,"LOAD LANGUAGE: language loaded successfully");
			maxidx++;
			updatewin(LWIN);
			chgelan(maxidx-1);
	}
} /* loadlan */
