/* 
   Bordeaux : 1995 
   */

#ifndef WIN_UNA2_H
#define WIN_UNA2_H

#include "ext.h"

/* This module implements some unary operations on the languages :
   - for the notion of root and free-hull see :
     [1] "Theory of codes", J.Berstel, D.Perrin, Academic Press, Orlando, 1985
   - for the notion of language of stack-words see :
     [2] "On stack languages", B.Patrou I.Litovsky B.Le Saec, Algebraic Theory and 
         Applications to Formal Languages and Codes, 1993, p 174-182 */
     

/* compute the root of a language of automatons X_dfa and X_nfa : see [1] 
   assume that X_dfa is minimal */
dfa win_una2_root(dfa X_dfa, nfa X_nfa);

/* compute the free hull of a language of automatons X_dfa and X_nfa : see [1] 
   assume that X_dfa and X_nfa are minimal */
dfa win_una2_free_hull(dfa X_dfa, nfa X_nfa);

/* compute the language of stack-words of a language of DFA X_df : see [2] 
   assume that X_dfa is minimal */
dfa win_una2_stack(dfa X_dfa);

#endif  WIN_UNA2_H

