/* writeamr.c 3.1 (KIEL) 01.95 */

#include "ext.h"
extern char *versiontext[];

/* functions included:
 *
 *	static	char*	i2a()
 *	      	char*	pi2a()
 *	static	char*	be2a()
 *	static	char*	bx2a()
 *
 *	static	void	writestr()
 *	static	void	writerex()
 *	static	void	writeform()
 *	static	void	writedfa()
 *	static	void	writenfa()
 *	static	void	writedcl()
 *	static	void	writemon()
 *	static	void	writesf()
 *	      	boolx	writelan()
 */



/******************************************************************/
/******************************************************************/
static char*
i2a(i)
     int i;
{	
  (void)sprintf(dummy,IFMT,i);
  return dummy;
} /* i2a */

/******************************************************************/
char*
pi2a(pi)
     posint pi;
{
  (void)sprintf(dummy,PIF,pi);
  return dummy;
} /* pi2a */

/******************************************************************/
static char*
be2a(bval)
     boole bval;
{	
  return (bval)? "T\n" : "F\n";
} /* be2a */

/******************************************************************/
static char*
bx2a(bxval)
     boolx bxval;
{	
  switch (bxval) 
    {
    case TRUE:
      return "T\n";
    case FALSE:
      return "F\n";
    case UN_KNOWN:
      return "U\n";
    default:
      errex(SWERR,"file.c: bx2a");
    } /* end switch */
  /* NOTREACHED */
} /* bx2a */

/******************************************************************/
static void
writestr(str,strl)
     register string str;
     register posint strl;
{ 
  char ch;
  
  while (strl > LINELEN) 
    {
      strl -= LINELEN;
      ch = str[LINELEN]; 
      str[LINELEN] = '\0';
      fwrite(str); new_line;
      str[LINELEN] = ch;
      str += LINELEN;
    }
  if (strl) 
    {
      fwrite(str); new_line; 
    }
  new_line;
} /* writestr */

/******************************************************************/
static void
writerex(crex)
     regex crex;
{ 
  int i;
  
  fwrite(text[REGNO]);
  fwrite(pi2a((posint)(crex->useda + 1))); 
  new_line;
  fwrite(pi2a(crex->sno)); 
  new_line;
  fwrite(text[REGNO+1]);
  fwrite(pi2a(crex->rexl)); 
  new_line;
  fwrite(pi2a(crex->erexl)); 
  new_line;
  fwrite(text[REGNO+2]);
  fwrite(be2a(TRUE));
  fwrite(be2a(crex->grex));
  fwrite(text[REGNO+3]);
  
  for(i=0; i <= crex->useda; i++) 
    {
      fwrite(pi2a(crex->abbl[i])); 
      new_line;
    }
	
  fwrite(text[REGNO+4]);
  for(i=0; i <= crex->useda; i++) 
    {
      writestr(crex->abbr[i],crex->abbl[i]);
      new_line;
    }
	
  fwrite(text[REGNO+5]);
  writestr(crex->rex,crex->rexl);
  new_line;
  writestr(crex->exprex,crex->erexl);
} /* writerex */

/******************************************************************/
static void
writedfa(cdfa)
     dfa cdfa;
{ 
  register posint i,j;
  
  fwrite(text[DFANO]);
  fwrite(pi2a(cdfa->qno)); 
  new_line;
  fwrite(text[DFANO+2]);
  fwrite(pi2a(cdfa->init)); 
  new_line;
  fwrite(text[DFANO+3]);
  fwrite(pi2a(cdfa->sno)); 
  new_line;
  fwrite(text[DFANO+4]);
  fwrite(be2a(cdfa->minimal));
  fwrite(text[DFANO+5]);
  
  for(i=0; i<=cdfa->qno; )
    fwrite(bx2a(cdfa->final[i++]));
  
  fwrite(text[DFANO+6]);
  for(i=1; i<=cdfa->sno; i++)
    for(j=0; j<=cdfa->qno; ) 
      {
	fwrite(pi2a(cdfa->delta[i][j++]));
	new_line;
      }
  fwrite(text[DFANO+7]);
} /* writedfa */

/******************************************************************/
static void
writenfa(cnfa)
     nfa cnfa;
{ 
  register posint i,j,k;
	
  fwrite(text[NFANO]);
  fwrite(pi2a(cnfa->qno)); 
  new_line;

  /*	fwrite(text[NFANO+2]);
	fwrite(pi2a(0)); new_line; */
 
  fwrite(text[NFANO+3]);
  fwrite(pi2a(cnfa->sno)); new_line;
  fwrite(text[NFANO+4]);
  fwrite(be2a(cnfa->is_eps));
  /*	fwrite(be2a(FALSE));*/
  fwrite(be2a(cnfa->minimal));
  fwrite(text[NFANO+5]);
  for(i=0; i<=cnfa->qno; )
    fwrite(i2a(cnfa->infin[i++]));
  fwrite(text[NFANO+6]);
  for(k=0; k<=lastdelta(cnfa->qno); k++)
    for(i=(cnfa->is_eps)?0:1; i<=cnfa->sno; i++)
      for(j=0; j<=cnfa->qno; j++) 
	{
	  fwrite(i2a((int)cnfa->delta[i][j][k]));
	}
  fwrite(text[NFANO+7]);
} /* writenfa */

/******************************************************************/
static void
writedcl(cdcl)
     dstruct cdcl;
{ 
  posint i;
  register posint j;
  register darray dc;
	
  fwrite(text[DCLNO]);
  fwrite(pi2a(cdcl->dno)); 
  new_line;
  fwrite(text[DCLNO+1]);
  fwrite(pi2a(cdcl->rno)); 
  new_line;
  fwrite(text[DCLNO+2]);
  fwrite(pi2a(cdcl->lno)); 
  new_line;

  /*	fwrite(text[DCLNO+3]);
	fwrite(pi2a(cdcl->minrang)); new_line; */
  
  fwrite(text[DCLNO+4]);
  dc = cdcl->dclassarray;
  for(i=0; i < cdcl->dno; i++) 
    {
      fwrite(text[DCLNO+5]);
      fwrite(pi2a(dc[i]->org)); 
      new_line;
      fwrite(pi2a(dc[i]->rno)); 
      new_line;
      fwrite(pi2a(dc[i]->lno)); 
      new_line;
      fwrite(pi2a(dc[i]->hsize));
      new_line;
      fwrite(pi2a(dc[i]->rang));
      new_line;
      fwrite(pi2a(dc[i]->maxlen));
      new_line;
      fwrite(be2a(dc[i]->regular));
      fwrite(text[DCLNO+6]);
      for(j=0; j < dc[i]->lno; ) 
	{
	  fwrite(pi2a(dc[i]->lrep[j++])); 
	  new_line;
	}
      fwrite(text[DCLNO+7]);
      for(j=0; j < dc[i]->rno; ) 
	{
	  fwrite(pi2a(dc[i]->rrep[j++])); 
	  new_line;
	}
      fwrite(text[DCLNO+8]);
      for(j=0; j < dc[i]->hsize; ) 
	{
	  fwrite(pi2a(dc[i]->hclass[j++])); 
	  new_line;
	}
    }
} /* writedcl */

/******************************************************************/
static void
writemon(cmon)
     register monoid cmon;
{ 
  register posint i,j;
  
  fwrite(text[MONNO]);
  fwrite(pi2a(cmon->qno)); 
  new_line;
  fwrite(text[MONNO+2]);
  fwrite(pi2a(cmon->sno)); 
  new_line;
  fwrite(text[MONNO+3]);
  fwrite(pi2a(cmon->mno)); 
  new_line;
  fwrite(text[MONNO+4]);
  fwrite(pi2a(cmon->gno)); 
  new_line;
  fwrite(text[MONNO+8]);
  fwrite(pi2a(cmon->zero)); 
  new_line;
  fwrite(text[MONNO+14]);

  /* oma */
  if (cmon->relationcomputed) 
    { 
      fwrite(pi2a(cmon->rs->rno)); 
      new_line;
      for(i=0; i < cmon->rs->rno; i++) 
	{
	  fwrite(pi2a(cmon->rs->rside[i])); 
	  new_line;
	  fwrite(pi2a(cmon->rs->lside[i])); 
	  new_line;
	}
    } 
  else 
    {  
      fwrite(pi2a(0)); 
      new_line; /* cmon->rs->rno == 0 indicates that 
		   defining relations have not been
		   computed */
    }
  
  fwrite(text[MONNO+5]);
  for(i=0; i <= cmon->gno; ) 
    {
      fwrite(pi2a(cmon->generator[i++])); 
      new_line;
    }
  fwrite(text[MONNO+6]);
  for(i=0; i <= cmon->sno; ) 
    {
      fwrite(pi2a(cmon->let2gen[i++]));
      new_line;
    }
  fwrite(text[MONNO+7]);
  for(i=0; i < cmon->mno; i++) 
    {
      for(j=1; j <= cmon->gno; ) 
	{
	  fwrite(pi2a(cmon->gensucc[i][j++])); 
	  new_line;
	}
      new_line;
    }
  fwrite(text[MONNO+11]);
  fwrite(be2a(cmon->dclassiscomputed));
  fwrite(be2a(cmon->mequals));
  fwrite(text[MONNO+12]);
  if (cmon->dclassiscomputed) 
    {
      fwrite(text[MONNO+13]);
      
      /*		for(i=0; i < cmon->mno; i++) {
			fwrite(pi2a(0)); new_line; 
			}
			*/
      writedcl(cmon->ds);
    }
} /* writemon */

/******************************************************************/
static void
writesf(csf,mno)
     register starfexp csf;
     posint mno;
{ 
  register posint i,j;
	
  fwrite(text[SFENO]);
  for(i=0; i < mno;) 
    {
      fwrite(pi2a(csf->ulength[i++]));
      new_line;
    }
  fwrite(text[SFENO+1]);
  for(i=0; i < mno;) 
    {
      fwrite(pi2a(csf->vlength[i++]));
      new_line;
    }
  fwrite(text[SFENO+2]);
  for(i=0; i < mno;) 
    {
      fwrite(pi2a(csf->w0length[i++])); 
      new_line;
    }
  fwrite(text[SFENO+3]);
  for(i=0; i < mno;) 
    {
      fwrite(pi2a(csf->w1length[i++]));
      new_line;
    }
  fwrite(text[SFENO+4]);
  for(i=0; i < mno; i++)
    for(j=0; j < 2*csf->ulength[i];) 
      {
	fwrite(pi2a(csf->u[i][j++])); 
	new_line;
      }
  fwrite(text[SFENO+5]);
  for(i=0; i < mno; i++)
    for(j=0; j < 2*csf->vlength[i];) 
      {
	fwrite(pi2a(csf->v[i][j++]));
	new_line;
      }
  fwrite(text[SFENO+6]);
  for(i=0; i < mno; i++)
    for(j=0; j < 3*csf->w0length[i];) 
      {
	fwrite(pi2a(csf->w0[i][j++]));
	new_line;
      }
  fwrite(text[SFENO+7]);
  for(i=0; i < mno; i++)
    for(j=0; j < csf->w1length[i];) 
      {
	fwrite(pi2a(csf->w1[i][j++])); 
	new_line;
      }
  fwrite(text[SFENO+8]);
  for(i=0; i < mno;) fwrite(be2a(csf->computed[i++]));
  fwrite(text[SFENO+9]);
} /* writesf */

/******************************************************************/
boolx
writelan(idx)
     int idx;
{ 
  char fname[PATHLEN+NLEN+5]; /* add .amr to the name */
  register language lanout;

  lanout = langs[idx];
  
  (void)strcpy(fname,workdir);
  (void)strcat(fname,lanout->name);
  (void)strcat(fname,".amr");
  if ((amrp=fopen(fname,"w")) == NULL) 
    {
#ifdef DEBUG
      perror("writelan 1");
#endif
      return FALSE;
    }
  
  fwrite(text[GLBNO]);

  fwrite(versiontext[CUR_VERSION]);

  fwrite(text[GLBNO+1]);

  fwrite(lanout->name); 
  new_line;

  fwrite(lanout->ref); 
  new_line;

  fwrite(text[GLBNO+2]);

  fwrite(pi2a(lanout->sizeal));
  new_line;

  fwrite(text[GLBNO+3]);

  fwrite(i2a(lanout->inputis));

  switch (lanout->inputis) 
    {
    case REXINP:
    case DFAINP:
    case NFAINP:
      break;
    case OREXINP:
      writerex(lanout->orex); 
      break;
    case ODFAINP:
      writedfa(lanout->odfa); 
      break;
    case ONFAINP:
      writenfa(lanout->onfa);
      break;
    case OENFAINP:
      writenfa(lanout->oenfa); 
      break;
    default: 
      errex(SWERR,"WRITELAN");
    }
  
  fwrite(text[GLBNO+4]);

  fwrite(text[GLBNO+5]);

  fwrite(be2a(lanout->brex));
  if (lanout->brex) 
    writerex(lanout->lrex);

  fwrite(text[GLBNO+6]);

  fwrite(be2a(lanout->bdfa));
  if (lanout->bdfa) 
    writedfa(lanout->ldfa);

  fwrite(text[GLBNO+7]);

  fwrite(be2a(lanout->bnfa));
  if (lanout->bnfa) 
    writenfa(lanout->lnfa);

  fwrite(text[GLBNO+8]);
	
  fwrite(be2a(lanout->bmon));
  if (lanout->bmon) 
    writemon(lanout->lmon);
	
  fwrite(text[GLBNO+9]);
  
  fwrite(be2a(lanout->stariscomp));
  if (lanout->stariscomp)
    writesf(lanout->sexp,lanout->lmon->mno);
	
  fwrite(text[GLBNO+10]);
	
  fwrite(bx2a(lanout->empty));	
  fwrite(bx2a(lanout->full));
  fwrite(bx2a(lanout->folu));
  fwrite(bx2a(lanout->starfree));
  fwrite(bx2a(lanout->localtest));
  fwrite(bx2a(lanout->definite));
  fwrite(bx2a(lanout->revdefinite));
  fwrite(bx2a(lanout->gendefinite));
  fwrite(bx2a(lanout->dotdepth1));
  fwrite(bx2a(lanout->piecetest));
  fwrite(bx2a(lanout->nilpotent));

  /* --- Bordeaux : 1995 : start --- */

  fwrite(text[GLBNO+11]);              
  fwrite(bx2a(lanout->code));        	
  fwrite(bx2a(lanout->stack_code));     

  fwrite(text[GLBNO+12]);               
  fwrite(bx2a(lanout->prefix_code));    
  fwrite(bx2a(lanout->suffix_code));    
  fwrite(bx2a(lanout->bifix_code));     
  fwrite(bx2a(lanout->p_infix_code));   
  fwrite(bx2a(lanout->s_infix_code));   
  fwrite(bx2a(lanout->infix_code));     

  fwrite(text[GLBNO+13]);                     
  fwrite(bx2a(lanout->right_semaphore_code)); 
  fwrite(bx2a(lanout->left_semaphore_code));  

  fwrite(text[GLBNO+14]);                
  fwrite(bx2a(lanout->outfix_code));     
  fwrite(bx2a(lanout->hypercode));       
  fwrite(bx2a(lanout->uniform_code));    
  fwrite(bx2a(lanout->full_uniform_code));

  fwrite(text[GLBNO+15]);                 
  fwrite(lanout->word_not_code);          
  new_line;

  /* --- Bordeaux : 1995 : end --- */

  fwrite(text[GLBNO+16]);
  fwrite(pi2a(lanout->localdegree));
  
	
  if (ferror(amrp)) 
    {
      (void)fclose(amrp);
      return UN_KNOWN;
    }
  (void)fclose(amrp);
#ifdef UNIX
  if(chmod(fname,0664) == -1)
    return UN_KNOWN;
#endif
  return TRUE;
} /* writelan */













































